# generated by datamodel-codegen:
#   filename:  openapi.json
#   timestamp: 2023-04-28T14:45:34+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Any, Dict, List, Optional

from pydantic import Field

from kelvin.sdk.client.base_model import BaseModelRoot
from kelvin.sdk.client.data_model import DataModelBase


class ACPLocationItem(DataModelBase):
    """
    ACPLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = None
    lon: Optional[float] = None


class ACPMetadataBulkCreateItem(DataModelBase):
    """
    ACPMetadataBulkCreateItem object.

    Parameters
    ----------
    acp_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    acp_name: Optional[str] = None
    name: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None


class ACPMetadataBulkDeleteItem(DataModelBase):
    """
    ACPMetadataBulkDeleteItem object.

    Parameters
    ----------
    acp_name: Optional[str]
    name: Optional[str]

    """

    acp_name: Optional[str] = None
    name: Optional[str] = None


class ACPMetadataCreate(DataModelBase):
    """
    ACPMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(None, max_length=64)
    payload: Optional[Dict[str, Any]] = None


class ACPMetadataUpdate(DataModelBase):
    """
    ACPMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class ACPSettingAutoUpdate(DataModelBase):
    """
    ACPSettingAutoUpdate object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ACPSettingMetrics(DataModelBase):
    """
    ACPSettingMetrics object.

    Parameters
    ----------
    enabled: Optional[bool]
    interval: Optional[int]

    """

    enabled: Optional[bool] = None
    interval: Optional[int] = None


class ACPSettingSync(DataModelBase):
    """
    ACPSettingSync object.

    Parameters
    ----------
    interval: Optional[int]

    """

    interval: Optional[int] = None


class ACPStatusUpdateValues(DataModelBase):
    """
    ACPStatusUpdateValues object.

    Parameters
    ----------
    message: Optional[str]
    state: Optional[str]
    warnings: Optional[List[str]]

    """

    message: Optional[str] = None
    state: Optional[str] = None
    warnings: Optional[List[str]] = None


class ACPUpdate(DataModelBase):
    """
    ACPUpdate object.

    Parameters
    ----------
    location: Optional[ACPLocationItem]
    manifests_scrape_interval: Optional[int]
    sync_scrape_interval: Optional[int]
    telemetry_scrape_interval: Optional[int]
    title: Optional[str]

    """

    location: Optional[ACPLocationItem] = None
    manifests_scrape_interval: Optional[int] = None
    sync_scrape_interval: Optional[int] = None
    telemetry_scrape_interval: Optional[int] = None
    title: Optional[str] = Field(None, max_length=64)


class AlarmClassCreate(DataModelBase):
    """
    AlarmClassCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmClassUpdate(DataModelBase):
    """
    AlarmClassUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(None, max_length=64)


class AlarmClustering(DataModelBase):
    """
    AlarmClustering object.

    Parameters
    ----------
    alarm_severities: Optional[List[int]]
    asset_include_children: Optional[bool]
    end_date: Optional[datetime]
    start_date: Optional[datetime]
    target_asset_names: Optional[List[str]]
    time_bucket: Optional[str]

    """

    alarm_severities: Optional[List[int]] = None
    asset_include_children: Optional[bool] = None
    end_date: Optional[datetime] = None
    start_date: Optional[datetime] = None
    target_asset_names: Optional[List[str]] = None
    time_bucket: Optional[str] = None


class AlarmConditionTargetNotificationsUserSetting(DataModelBase):
    """
    AlarmConditionTargetNotificationsUserSetting object.

    Parameters
    ----------
    enabled: Optional[bool]
    type: Optional[str]

    """

    enabled: Optional[bool] = None
    type: Optional[str] = None


class AlarmFilterCreate(DataModelBase):
    """
    AlarmFilterCreate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]
    title: Optional[str]
    username: Optional[str]
    version: Optional[str]

    """

    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = None
    username: Optional[str] = None
    version: Optional[str] = None


class AlarmFilterUpdate(DataModelBase):
    """
    AlarmFilterUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]
    title: Optional[str]
    version: Optional[str]

    """

    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = None
    version: Optional[str] = None


class AlarmSeverity(DataModelBase):
    """
    AlarmSeverity object.

    Parameters
    ----------
    name: Optional[str]
    severity: Optional[int]
    title: Optional[str]

    """

    name: Optional[str] = None
    severity: Optional[int] = None
    title: Optional[str] = None


class AlarmSeverityUpdate(DataModelBase):
    """
    AlarmSeverityUpdate object.

    Parameters
    ----------
    data: Optional[List[AlarmSeverity]]

    """

    data: Optional[List[AlarmSeverity]] = None


class AlarmStatisticsExtraField(DataModelBase):
    """
    AlarmStatisticsExtraField object.

    Parameters
    ----------
    name: Optional[str]
    severities: Optional[List[int]]
    statuses: Optional[List[str]]

    """

    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-alarms/' target='_blank'>Kelvin Alarm</a> group `extra_field`.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    severities: Optional[List[int]] = Field(
        None,
        description="List of severities to filter <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-alarms/' target='_blank'>Kelvin Alarm</a> for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> Options available are; `1` (critical), `2` (urgent), `3` (advisory), `4` (medium), `5` (low).</p> Example : `[1,2,5]`",
    )
    statuses: Optional[List[str]] = Field(
        None,
        description="List of statuses to filter <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-alarms/' target='_blank'>Kelvin Alarm</a> for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> Options available are; `active`, `acknowledge` and `resolved`.</p> Example : `[\"active\", \"acknowledge\"]`",
    )


class AlarmTagCreate(DataModelBase):
    """
    AlarmTagCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmTagUpdate(DataModelBase):
    """
    AlarmTagUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class AlarmTypeCreate(DataModelBase):
    """
    AlarmTypeCreate object.

    Parameters
    ----------
    alarm_class_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    alarm_class_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmTypeUpdate(DataModelBase):
    """
    AlarmTypeUpdate object.

    Parameters
    ----------
    alarm_class_name: Optional[str]
    title: Optional[str]

    """

    alarm_class_name: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class AlarmUpdate(DataModelBase):
    """
    AlarmUpdate object.

    Parameters
    ----------
    alarm_type_name: Optional[str]
    custom_identifier: Optional[str]
    description: Optional[str]
    payload: Optional[Dict[str, Any]]
    severity: Optional[int]
    solution: Optional[str]
    source_asset_names: Optional[List[str]]
    tags: Optional[List[str]]
    target_asset_name: Optional[str]
    title: Optional[str]

    """

    alarm_type_name: Optional[str] = None
    custom_identifier: Optional[str] = None
    description: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None
    severity: Optional[int] = None
    solution: Optional[str] = None
    source_asset_names: Optional[List[str]] = None
    tags: Optional[List[str]] = None
    target_asset_name: Optional[str] = None
    title: Optional[str] = None


class AlarmUpdateStatus(DataModelBase):
    """
    AlarmUpdateStatus object.

    Parameters
    ----------
    status: Optional[str]
    status_payload: Optional[Dict[str, Any]]

    """

    status: Optional[str] = None
    status_payload: Optional[Dict[str, Any]] = None


class Analysis(DataModelBase):
    """
    Analysis object.

    Parameters
    ----------
    analysis_name: Optional[str]
    inspection_score: Optional[int]
    recommendation: Optional[str]

    """

    analysis_name: Optional[str] = None
    inspection_score: Optional[int] = None
    recommendation: Optional[str] = None


class AppCreate(DataModelBase):
    """
    AppCreate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class AppUpdate(DataModelBase):
    """
    AppUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class AssetClassCreate(DataModelBase):
    """
    AssetClassCreate object.

    Parameters
    ----------
    entity_type_name: str
    name: str
    title: str

    """

    entity_type_name: str = Field(
        ...,
        description="<a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Type</a> that is linked to this new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class\" target=\"_blank\">Kelvin Asset Class</a>.</p> There are 5 <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Type</a> options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> and function of each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Type</a> can be found at <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.",
        max_length=64,
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetClassUpdate(DataModelBase):
    """
    AssetClassUpdate object.

    Parameters
    ----------
    entity_type_name: Optional[str]
    title: str

    """

    entity_type_name: Optional[str] = Field(
        None,
        description='New entity type that is linked to this existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
        max_length=64,
    )
    title: str = Field(
        ...,
        description='New display name for this existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetDataStreamsList(DataModelBase):
    """
    AssetDataStreamsList object.

    Parameters
    ----------
    include_asset_children: Optional[bool]

    """

    include_asset_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair objects for the `asset_name` declared.",
    )


class AssetInsightsSortBy(DataModelBase):
    """
    AssetInsightsSortBy object.

    Parameters
    ----------
    direction: Optional[str]
    field: Optional[str]
    sort_by_extra_field: Optional[bool]

    """

    direction: Optional[str] = Field(
        "asc",
        description="Sorting order for the results according to the `field` parameter.</p> There are two options; `asc` (ascending order) and `desc` (descending order).</p> The default is `asc` (ascending).",
    )
    field: Optional[str] = Field(
        "name",
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> or `extra_field` field to sort by. Source of field will be determined by the `SortByExtraField` key.",
    )
    sort_by_extra_field: Optional[bool] = Field(
        None,
        description="Choose the source of the `field` parameter. If `true`, the field name will be from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> names. If `false`. the field name will be from the `extra_field[].name` field.",
    )


class AssetLocationItem(DataModelBase):
    """
    AssetLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = Field(
        None,
        description='Latitude coordinates of where the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> is geographically located.</p> This is saved in decimal degree format. e.g. `37.774929`.</p> The default is 0.',
    )
    lon: Optional[float] = Field(
        None,
        description='Longitude coordinates of where the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> is geographically located.</p> This is saved in decimal degree format. e.g. `\t-122.419416`.</p> The default is 0.',
    )


class AssetMetricItem(DataModelBase):
    """
    AssetMetricItem object.

    Parameters
    ----------
    name: Optional[str]

    """

    name: Optional[str] = Field(None, description="Unused. This is reserved as a future feature.")


class AssetOEEGet(DataModelBase):
    """
    AssetOEEGet object.

    Parameters
    ----------
    asset_names: List[str]

    """

    asset_names: List[str] = Field(
        ...,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the OEE statistics.",
    )


class AssetPropertyCreate(DataModelBase):
    """
    AssetPropertyCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description='Unique identifier name for this property in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: Optional[str] = Field(
        None,
        description='Display name (title) for this property in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    value: Optional[str] = Field(None, description="Value for this property.")


class AssetPropertyExtraField(DataModelBase):
    """
    AssetPropertyExtraField object.

    Parameters
    ----------
    name: Optional[str]
    property_name: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> `extra_field`.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    property_name: Optional[str] = Field(
        None,
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> property to include.</p> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> properties are custom fields that can be created with the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )


class AssetStatistics(DataModelBase):
    """
    AssetStatistics object.

    Parameters
    ----------
    asset_type_names: Optional[List[str]]
    entity_type_names: Optional[List[str]]
    names: Optional[List[str]]
    search: Optional[List[str]]

    """

    asset_type_names: Optional[List[str]] = Field(
        None,
        description="Array of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Types</a> to be included in the filter.",
    )
    entity_type_names: Optional[List[str]] = Field(
        None,
        description="Array of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets#entity-type' target='_blank'>Entity Types</a> to be included in the filter. There are five options available for the array; `group`, `asset`, `component`, `part` or `sensor`.",
    )
    names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> to return statistics on.</p> OEE information will only be included for <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="Search and filter the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> list. The `name`, `title`, `asset_type_name`, `asset_type_title`, `entity_type_name` and `entity_type_title` will be included in the search field criteria. This is given as an array, for example `[pump,fan]`.</p> The search is case insensitive and will find partial matches as well. For example if a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> name or display name is `centrifugal_pump`, then a match will be made if the search string is `pum` or `FUGaL`.",
    )


class AssetTemplateProperties(DataModelBase):
    """
    AssetTemplateProperties object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description='Default unique identifier name for this property in the new Kelvin Template.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    title: Optional[str] = Field(
        None,
        description='Default display name (title) for this property in the new Kelvin Template. This is a friendly name displayed in lists and in references.</p> You can use any character, numeric, space and special character in this parameter.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    value: Optional[str] = Field(
        None,
        description='Default value for this property. This can be a string, integer, float or boolean.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )


class AssetTypeCreate(DataModelBase):
    """
    AssetTypeCreate object.

    Parameters
    ----------
    asset_class_name: str
    name: str
    title: str

    """

    asset_class_name: str = Field(
        ...,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> A 400 error will occur if the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> does not exist and this API request will fail.',
        max_length=64,
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    title: str = Field(
        ...,
        description='Display name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetTypeMetadataCreate(DataModelBase):
    """
    AssetTypeMetadataCreate object.

    Parameters
    ----------
    name: str
    payload: Dict[str, Any]

    """

    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    payload: Dict[str, Any] = Field(
        ...,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class AssetTypeMetadataUpdate(DataModelBase):
    """
    AssetTypeMetadataUpdate object.

    Parameters
    ----------
    payload: Dict[str, Any]

    """

    payload: Dict[str, Any] = Field(
        ...,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class AssetTypeUpdate(DataModelBase):
    """
    AssetTypeUpdate object.

    Parameters
    ----------
    asset_class_name: Optional[str]
    title: Optional[str]

    """

    asset_class_name: Optional[str] = Field(
        None,
        description='Link to a different existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.</p> Use the name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> in this parameter and not the Display Name (title). The <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> must be created and existing before you can change the link here.',
        max_length=64,
    )
    title: Optional[str] = Field(
        None,
        description='New display name(title) for this existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )


class AssetWorkloadsList(DataModelBase):
    """
    AssetWorkloadsList object.

    Parameters
    ----------
    asset_names: Optional[List[str]]

    """

    asset_names: Optional[List[str]] = None


class BridgeDeploy(DataModelBase):
    """
    BridgeDeploy object.

    Parameters
    ----------
    acp_name: str
    name: str
    payload: Dict[str, Any]
    protocol: str
    title: str

    """

    acp_name: str = Field(
        ...,
        description="Unique identifier name of an existing <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    name: str = Field(
        ...,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Dict[str, Any] = Field(
        ...,
        description="Custom JSON object holding all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs and their communication specifications and addresses.</p> This JSON structure will depend on the type of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> bring deployed. The type is the Protocol parameter here.",
    )
    protocol: str = Field(
        ...,
        description="This is the type of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> communication protocol. There are four protocols available; `opc-ua`, `mqtt`, `modbus`, `roc`. Full details about these protocols are explained in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Documentation Overview</a>",
        max_length=64,
    )
    title: str = Field(
        ...,
        description="Display name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )


class CarbonEmissionsSetting(DataModelBase):
    """
    CarbonEmissionsSetting object.

    Parameters
    ----------
    co2_per_kwh: Optional[float]
    co2_per_metric_tone: Optional[float]
    cost_per_kwh: Optional[float]
    daily_runtime: Optional[float]
    forest_acres_factor: Optional[float]
    forest_acres_preserved_factor: Optional[float]
    power_consumption_factor: Optional[float]
    tree_seedlings_factor: Optional[float]
    workload_percentage: Optional[float]
    year_work_days: Optional[int]

    """

    co2_per_kwh: Optional[float] = None
    co2_per_metric_tone: Optional[float] = None
    cost_per_kwh: Optional[float] = None
    daily_runtime: Optional[float] = None
    forest_acres_factor: Optional[float] = None
    forest_acres_preserved_factor: Optional[float] = None
    power_consumption_factor: Optional[float] = None
    tree_seedlings_factor: Optional[float] = None
    workload_percentage: Optional[float] = None
    year_work_days: Optional[int] = None


class ClusterLocationItem(DataModelBase):
    """
    ClusterLocationItem object.

    Parameters
    ----------
    lat: Optional[float]
    lon: Optional[float]

    """

    lat: Optional[float] = None
    lon: Optional[float] = None


class ClusterUpdate(DataModelBase):
    """
    ClusterUpdate object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    kelvin_info: Optional[Dict[str, Any]]
    kubeconfig: Optional[str]
    network_info: Optional[Dict[str, Any]]
    ready: Optional[bool]
    system_info: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    info: Optional[Dict[str, Any]] = None
    kelvin_info: Optional[Dict[str, Any]] = None
    kubeconfig: Optional[str] = None
    network_info: Optional[Dict[str, Any]] = None
    ready: Optional[bool] = None
    system_info: Optional[Dict[str, Any]] = None
    title: Optional[str] = None


class ControlChangeClustering(DataModelBase):
    """
    ControlChangeClustering object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: Optional[List[str]]
    end_date: datetime
    metric_names: Optional[List[str]]
    start_date: datetime
    states: Optional[List[str]]
    time_bucket: str

    """

    asset_include_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>  objects for the `asset_names` declared.",
    )
    asset_names: Optional[List[str]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    end_date: datetime = Field(
        ...,
        description="Most recent (end) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    metric_names: Optional[List[str]] = Field(
        None,
        description='An array of one or more <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    start_date: datetime = Field(
        ...,
        description="Earliest (start) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    time_bucket: str = Field(
        ...,
        description="Time window to group and aggregate the occurrence of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a> within the defined time bucket.</p> Bucket time options available can be found at https://golang.org/pkg/time/#ParseDuration. For example '1h', '1m' or '2h45m'.",
    )


class ControlChangeCreate(DataModelBase):
    """
    ControlChangeCreate object.

    Parameters
    ----------
    asset_name: str
    expiration_date: Optional[datetime]
    metric_name: str
    payload: Optional[Dict[str, Any]]
    retry: Optional[int]
    timeout: Optional[int]

    """

    asset_name: str = Field(
        ...,
        description="Name of an existing <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    expiration_date: Optional[datetime] = Field(
        None,
        description="Date/time when the Control Change request will fail and return a `failed` status if it has not been `applied` yet.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.</p> The default value is calculated by the formulae <strong>Now + (`timeout` * ( `retry` + 1 ))</strong>.",
    )
    metric_name: str = Field(
        ...,
        description='Name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> in a deployed <a href=\'https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/\' target=\'_blank\'>Kelvin Bridge</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON structure with a `value` key and the new value to write to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair.</p> For example </p> <blockquote>\"payload\": {</br>&nbsp;&nbsp;&nbsp;&nbsp;\"value\": 888</br>}</blockquote>",
    )
    retry: Optional[int] = Field(
        None,
        description="How many times the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will try and send the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> request to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> before the change is tagged `failed` and no further attempts will be made.</p> The default value is 0.</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> sends a `processed` acknowledgment, then the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will stop any further retries and wait for an `applied` response.",
    )
    timeout: Optional[int] = Field(
        None,
        description="How long the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will wait in seconds for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> to send an `processed` acknowledgement before a retry will be attempted. If the total number of retries has reach its `retry` limit, then the change is tagged `failed` and no further attempts will be made.</p> The default is 300 seconds.",
    )


class ControlChangeExtraField(DataModelBase):
    """
    ControlChangeExtraField object.

    Parameters
    ----------
    metrics: Optional[List[str]]
    name: Optional[str]
    statuses: Optional[List[str]]

    """

    metrics: Optional[List[str]] = None
    name: Optional[str] = None
    statuses: Optional[List[str]] = None


class AssetName(BaseModelRoot[str]):
    """
    AssetName object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class MetricName(BaseModelRoot[str]):
    """
    MetricName object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class ControlChangeLast(DataModelBase):
    """
    ControlChangeLast object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: List[AssetName]
    metric_names: Optional[List[MetricName]]
    states: Optional[List[str]]
    status_limit: Optional[int]

    """

    asset_include_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>  objects for the `asset_names` declared.",
    )
    asset_names: List[AssetName] = Field(
        ...,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the last <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    metric_names: Optional[List[MetricName]] = Field(
        None,
        description='An array of one or more <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    status_limit: Optional[int] = Field(
        None,
        description="Max number of statuses fetched per <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.",
    )


class Id(BaseModelRoot[str]):
    """
    Id object.

    Parameters
    ----------
    __root__: str = Field(..., max_length=64)

    """

    __root__: str = Field(..., max_length=64)


class ControlChangeList(DataModelBase):
    """
    ControlChangeList object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: Optional[List[AssetName]]
    ids: Optional[List[Id]]
    metric_names: Optional[List[MetricName]]
    states: Optional[List[str]]
    status_limit: Optional[int]

    """

    asset_include_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>  objects for the `asset_names` declared.",
    )
    asset_names: Optional[List[AssetName]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    ids: Optional[List[Id]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> IDs, to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only UUID type strings.",
    )
    metric_names: Optional[List[MetricName]] = Field(
        None,
        description='An array of one or more <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    status_limit: Optional[int] = Field(
        None,
        description="Max number of statuses fetched per <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.",
    )


class ControlChangePayload(DataModelBase):
    """
    ControlChangePayload object.

    Parameters
    ----------
    expiration_date: Optional[datetime]
    payload: Optional[Dict[str, Any]]
    retries: Optional[int]
    timeout: Optional[int]

    """

    expiration_date: Optional[datetime] = Field(
        None,
        description="Date/time when the Control Change request will fail and return a `failed` status if it has not been `applied` yet.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.</p> The default value is calculated by the formulae <strong>Now + (`timeout` * ( `retry` + 1 ))</strong>.",
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON structure with a `value` key and the new value to write to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair.</p> For example </p> <blockquote>\"payload\": {</br>&nbsp;&nbsp;&nbsp;&nbsp;\"value\": 888</br>}</blockquote>",
    )
    retries: Optional[int] = Field(
        None,
        description="How many times the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will try and send the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> request to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> before the change is tagged `failed` and no further attempts will be made.</p> The default value is 0.</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> sends a `processed` acknowledgment, then the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will stop any further retries and wait for an `applied` response.",
    )
    timeout: Optional[int] = Field(
        None,
        description="How long the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> Manager will wait in seconds for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> to send an `processed` acknowledgement before a retry will be attempted. If the total number of retries has reach its `retry` limit, then the change is tagged `failed` and no further attempts will be made.</p> The default is 300 seconds.",
    )


class ControlChangeRange(DataModelBase):
    """
    ControlChangeRange object.

    Parameters
    ----------
    asset_include_children: Optional[bool]
    asset_names: List[AssetName]
    end_date: datetime
    metric_names: Optional[List[MetricName]]
    start_date: datetime
    states: Optional[List[str]]
    status_limit: Optional[int]

    """

    asset_include_children: Optional[bool] = Field(
        None,
        description="Include all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> objects for all children <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> The default is `false` and will only return the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>  objects for the `asset_names` declared.",
    )
    asset_names: List[AssetName] = Field(
        ...,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> that have occurred.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    end_date: datetime = Field(
        ...,
        description="Most recent (end) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    metric_names: Optional[List[MetricName]] = Field(
        None,
        description='An array of one or more <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    start_date: datetime = Field(
        ...,
        description="Earliest (start) date-time for the list of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Changes</a>.</p> Values for a given point in time must be given in RFC3339 format. e.g. `2022-08-12T00:00:00.000000Z`.",
    )
    states: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> states wanted.</p> Options are `pending`, `sent`, `applied` and `failed`.</p> This will only check and filter on the `last_state`. For example; For a demo <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> if in the `status_log` there is a `state` of `sent` and the `last_state` is `applied` a filter here on `sent` will not show this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.",
    )
    status_limit: Optional[int] = Field(
        None,
        description="Max number of statuses fetched per <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.",
    )


class ControlChangeStatusPayload(DataModelBase):
    """
    ControlChangeStatusPayload object.

    Parameters
    ----------
    message: Optional[str]
    payload: Optional[Dict[str, Any]]
    state: Optional[str]

    """

    message: Optional[str] = Field(
        None,
        description="A message about the change in status. This will only appear if there is a message attached.",
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description="`pending` status will show a blank dictionary. `sent`, `applied` and `failed` will show the current value of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics' target='_blank'>Kelvin Metric</a> pair.",
    )
    state: Optional[str] = Field(
        None,
        description="<a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> updated state.</p> There are four states available; `pending`, `sent`, `applied` and `failed`.",
    )


class ControlChangeUploadRequest(DataModelBase):
    """
    ControlChangeUploadRequest object.

    Parameters
    ----------
    id: str
    payload: Optional[ControlChangePayload]
    resource: Optional[str]
    source: Optional[str]
    timestamp: Optional[datetime]
    type: Optional[str]

    """

    id: str = Field(
        ...,
        description="Unique identifier id for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This ID is assigned to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> with the response to a `/control-changes/create` API request.</p> This must contain only lowercase alphanumeric characters and the `-` character only. For example `764168a8-0e1e-33aa-adc7-14dfbb78dfad`.",
    )
    payload: Optional[ControlChangePayload] = None
    resource: Optional[str] = Field(
        None,
        description="krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    source: Optional[str] = Field(
        None,
        description="krn:wl of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    timestamp: Optional[datetime] = Field(
        None,
        description='Time in ISO 8601 UTC date/time format. Example; "2022-08-22T08:41:01.657916Z".',
    )
    type: Optional[str] = Field(
        None,
        description='Type of the current Kelvin Message. In this particular case it should always be "control".',
    )


class ControlChangeUploadStatus(DataModelBase):
    """
    ControlChangeUploadStatus object.

    Parameters
    ----------
    id: Optional[str]
    payload: Optional[ControlChangeStatusPayload]
    resource: Optional[str]
    source: Optional[str]
    timestamp: Optional[datetime]
    trace_id: str
    type: Optional[str]

    """

    id: Optional[str] = Field(
        None,
        description="Unique identifier id for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This ID is assigned to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> with the response to a `/control-changes/create` API request.</p> This must contain only lowercase alphanumeric characters and the `-` character only. For example `764168a8-0e1e-33aa-adc7-14dfbb78dfad`.",
    )
    payload: Optional[ControlChangeStatusPayload] = None
    resource: Optional[str] = Field(
        None,
        description="krn:am of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>// <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    source: Optional[str] = Field(
        None,
        description="krn:wl of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    timestamp: Optional[datetime] = Field(
        None,
        description='Time in ISO 8601 UTC date/time format. Example; "2022-08-22T08:41:01.657916Z".',
    )
    trace_id: str = Field(
        ..., description="This is for internal purposes and is the same as the `id`."
    )
    type: Optional[str] = Field(
        None,
        description='Type of the current Kelvin Message. In this particular case it should always be "control-status".',
    )


class CreatedBy(DataModelBase):
    """
    CreatedBy object.

    Parameters
    ----------
    name: Optional[str]
    type: Optional[str]

    """

    name: Optional[str] = None
    type: Optional[str] = None


class Type(Enum):
    user = "user"
    workload = "workload"


class DataLabelSource(DataModelBase):
    """
    DataLabelSource object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    type: Optional[Type]

    """

    info: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON object of key/value pairs to describe the type source.</p> For `workload` this will normally have the name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-apps/' target='_blank'>Kelvin App</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> that creates this information or for `user` this will usually be the `username` and `user_id`.",
    )
    type: Optional[Type] = Field(
        None,
        description="The type of source process.</p> There are two options `workload` and `user`.",
    )


class DeleteSelector(DataModelBase):
    """
    DeleteSelector object.

    Parameters
    ----------
    asset_name: str
    name: str

    """

    asset_name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )


class Failure(DataModelBase):
    """
    Failure object.

    Parameters
    ----------
    analyses: Optional[List[Analysis]]
    effect: Optional[str]
    effect_likelihood: Optional[int]
    mode: Optional[str]
    part_class_name: Optional[str]
    reason: Optional[str]

    """

    analyses: Optional[List[Analysis]] = None
    effect: Optional[str] = None
    effect_likelihood: Optional[int] = None
    mode: Optional[str] = None
    part_class_name: Optional[str] = None
    reason: Optional[str] = None


class FailureAnalysisThreshold(DataModelBase):
    """
    FailureAnalysisThreshold object.

    Parameters
    ----------
    analysis_name: Optional[str]
    severity: Optional[int]
    type: Optional[str]
    units: Optional[str]
    value: Optional[float]

    """

    analysis_name: Optional[str] = None
    severity: Optional[int] = None
    type: Optional[str] = None
    units: Optional[str] = None
    value: Optional[float] = None


class FailureAnalysisThresholdsUpsert(DataModelBase):
    """
    FailureAnalysisThresholdsUpsert object.

    Parameters
    ----------
    thresholds: Optional[List[FailureAnalysisThreshold]]

    """

    thresholds: Optional[List[FailureAnalysisThreshold]] = None


class FailureClassCreate(DataModelBase):
    """
    FailureClassCreate object.

    Parameters
    ----------
    device_type_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    device_type_name: Optional[str] = None
    name: Optional[str] = None
    title: Optional[str] = None


class FailureClassHierarchyUpdateItem(DataModelBase):
    """
    FailureClassHierarchyUpdateItem object.

    Parameters
    ----------
    failure_class_name: Optional[str]
    inherited: Optional[bool]

    """

    failure_class_name: Optional[str] = None
    inherited: Optional[bool] = None


class FailureClassUpdate(DataModelBase):
    """
    FailureClassUpdate object.

    Parameters
    ----------
    device_type_name: Optional[str]
    title: Optional[str]

    """

    device_type_name: Optional[str] = None
    title: Optional[str] = None


class FailureDetectionProperty(DataModelBase):
    """
    FailureDetectionProperty object.

    Parameters
    ----------
    name: Optional[str]
    unit: Optional[str]
    value: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description='Unique identifier name for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> property.</p> This must match the existing available properties for each type of <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> model.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
    )
    unit: Optional[str] = Field(
        None,
        description='The units for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> property.',
    )
    value: Optional[str] = Field(
        None,
        description='The value for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> property.',
    )


class FailureDetectionTemplate(DataModelBase):
    """
    FailureDetectionTemplate object.

    Parameters
    ----------
    enabled: Optional[bool]
    failure_class_name: Optional[str]

    """

    enabled: Optional[bool] = Field(
        None,
        description='The default activation state of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p>  `true` (enabled) and `false` (disabled).</p> The default is `false` (disabled).</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    failure_class_name: Optional[str] = Field(
        None,
        description='The name (not the Display Name / Title) of the default <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection Class</a>.</p> This parameter is only used when <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> is enabled.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )


class FailureID(DataModelBase):
    """
    FailureID object.

    Parameters
    ----------
    effect: Optional[str]
    mode: Optional[str]
    part_class_name: Optional[str]
    reason: Optional[str]

    """

    effect: Optional[str] = None
    mode: Optional[str] = None
    part_class_name: Optional[str] = None
    reason: Optional[str] = None


class FailureOverview(DataModelBase):
    """
    FailureOverview object.

    Parameters
    ----------
    alarm_severities: Optional[List[int]]
    asset_names: Optional[List[str]]
    asset_type_names: Optional[List[str]]
    map_names: Optional[List[str]]
    parent_asset_name: Optional[str]
    search: Optional[List[str]]

    """

    alarm_severities: Optional[List[int]] = Field(
        None,
        description="Array of <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-alarms#alarm-severity' target='_blank'>Kelvin Maps Alarm Severity</a> to be used as an `OR` in the filtered results.</p> This is an integer number between 1 and 5, with; 1 representing `critical`, 2 is `urgent`, 3 is `advisory`, 4 is `medium` and 5 is `low`.",
    )
    asset_names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> to filter failure overview results.</p> Failure overview information will only be included for <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )
    asset_type_names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> to filter the failure overview results.",
    )
    map_names: Optional[List[str]] = Field(
        None,
        description="Array of names of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> to filter failure overview results.</p> Failure overview information will only be included for <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> which represent the process maps in <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview' target='_blank'>Kelvin Maps</a>. These have an entity type `production-line`.",
    )
    parent_asset_name: Optional[str] = Field(
        None,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> names to be used as an `OR`. All <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> will be in the filtered results. These must have be an entity type belonging to <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a>.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="Array of strings to be used as an `OR` in the filtered results.</p> Each string will be used to search the field `name`, `title`. The search is case insensitive.",
    )


class FailuresCreateUpdate(DataModelBase):
    """
    FailuresCreateUpdate object.

    Parameters
    ----------
    failures: Optional[List[Failure]]

    """

    failures: Optional[List[Failure]] = None


class FailuresDelete(DataModelBase):
    """
    FailuresDelete object.

    Parameters
    ----------
    failures: Optional[List[FailureID]]

    """

    failures: Optional[List[FailureID]] = None


class ICDField(DataModelBase):
    """
    ICDField object.

    Parameters
    ----------
    array: Optional[bool]
    description: Optional[str]
    name: Optional[str]
    type: Optional[str]

    """

    array: Optional[bool] = None
    description: Optional[str] = None
    name: Optional[str] = None
    type: Optional[str] = None


class ICDPayload(DataModelBase):
    """
    ICDPayload object.

    Parameters
    ----------
    class_name: Optional[str]
    description: Optional[str]
    fields: Optional[List[ICDField]]
    name: Optional[str]
    version: Optional[str]

    """

    class_name: Optional[str] = None
    description: Optional[str] = None
    fields: Optional[List[ICDField]] = None
    name: Optional[str] = None
    version: Optional[str] = None


class InstanceSettingUpdate(DataModelBase):
    """
    InstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class IntegrationAwsRegionCreate(DataModelBase):
    """
    IntegrationAwsRegionCreate object.

    Parameters
    ----------
    name: Optional[str]
    title: Optional[str]

    """

    name: Optional[str] = None
    title: Optional[str] = None


class IntegrationAwsRegionUpdate(DataModelBase):
    """
    IntegrationAwsRegionUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = None


class IntegrationConfiguration(DataModelBase):
    """
    IntegrationConfiguration object.

    Parameters
    ----------
    aws_access_key_id: Optional[str]
    aws_region: Optional[str]
    aws_secret_access_key: Optional[str]
    polling_rate: Optional[int]

    """

    aws_access_key_id: Optional[str] = None
    aws_region: Optional[str] = None
    aws_secret_access_key: Optional[str] = None
    polling_rate: Optional[int] = None


class IntegrationCreate(DataModelBase):
    """
    IntegrationCreate object.

    Parameters
    ----------
    configuration: Optional[IntegrationConfiguration]
    enable: Optional[bool]
    name: Optional[str]
    title: Optional[str]
    type: Optional[str]

    """

    configuration: Optional[IntegrationConfiguration] = None
    enable: Optional[bool] = None
    name: Optional[str] = None
    title: Optional[str] = None
    type: Optional[str] = None


class IntegrationUpdate(DataModelBase):
    """
    IntegrationUpdate object.

    Parameters
    ----------
    configuration: Optional[IntegrationConfiguration]
    enable: Optional[bool]
    title: Optional[str]

    """

    configuration: Optional[IntegrationConfiguration] = None
    enable: Optional[bool] = None
    title: Optional[str] = None


class KelvinCarbonEmissionsInstanceSettingUpdate(DataModelBase):
    """
    KelvinCarbonEmissionsInstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[CarbonEmissionsSetting]

    """

    payload: Optional[CarbonEmissionsSetting] = None


class KelvinContactInfoSetting(DataModelBase):
    """
    KelvinContactInfoSetting object.

    Parameters
    ----------
    email: Optional[str]
    phone_country_code: Optional[str]
    phone_number: Optional[str]

    """

    email: Optional[str] = None
    phone_country_code: Optional[str] = None
    phone_number: Optional[str] = None


class KelvinContactInfoUserSettingUpdate(DataModelBase):
    """
    KelvinContactInfoUserSettingUpdate object.

    Parameters
    ----------
    payload: Optional[KelvinContactInfoSetting]

    """

    payload: Optional[KelvinContactInfoSetting] = None


class LabelCreate(DataModelBase):
    """
    LabelCreate object.

    Parameters
    ----------
    name: str
    title: str

    """

    name: str = Field(
        ...,
        description="Unique identifier name for the Label.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> This is the name used when referenced from <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a>",
        max_length=64,
    )
    title: str = Field(
        ...,
        description="Display name for this new Label. This is a friendly name for the Label.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )


class LabelMetadataBulkCreateItem(DataModelBase):
    """
    LabelMetadataBulkCreateItem object.

    Parameters
    ----------
    label_name: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    label_name: Optional[str] = Field(
        None,
        description="This is the name from the Label variable which can be created with the Kelvin API `/datalabels/labels/create`.</p> If the Label name does not exist, it will be automatically created.",
        max_length=64,
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class LabelMetadataCreate(DataModelBase):
    """
    LabelMetadataCreate object.

    Parameters
    ----------
    name: Optional[str]
    payload: Optional[Dict[str, Any]]

    """

    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Optional[Dict[str, Any]] = Field(
        None,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class LabelMetadataDeleteBulkItem(DataModelBase):
    """
    LabelMetadataDeleteBulkItem object.

    Parameters
    ----------
    label_name: Optional[str]
    name: Optional[str]

    """

    label_name: Optional[str] = Field(
        None,
        description="This is the name from the Label variable which can be created with the Kelvin API `/datalabels/labels/create`.</p> If the Label name does not exist, it will be automatically created.",
        max_length=64,
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> metadata parameter.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )


class LabelMetadataUpdate(DataModelBase):
    """
    LabelMetadataUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = Field(
        None,
        description='Custom JSON object defined by you.</p> This can be any valid JSON structure. For example this is valid</p> <blockquote>{</br>&nbsp;&nbsp;"key1": "A string here",</br>&nbsp;&nbsp;"key2": 88,</br>&nbsp;&nbsp;"key3": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey1": "Another String",</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"subkey2": true,</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>',
    )


class LabelUpdate(DataModelBase):
    """
    LabelUpdate object.

    Parameters
    ----------
    title: Optional[str]

    """

    title: Optional[str] = Field(
        None,
        description="Display name for this new Label. This is a friendly name for the Label.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )


class LoopConfig(DataModelBase):
    """
    LoopConfig object.

    Parameters
    ----------
    every: Optional[int]

    """

    every: Optional[int] = None


class MapOEEGet(DataModelBase):
    """
    MapOEEGet object.

    Parameters
    ----------
    map_names: List[str]

    """

    map_names: List[str] = Field(
        ...,
        description="Unique identifier name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a> that contains the wanted OEE data.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class MapRelationship(DataModelBase):
    """
    MapRelationship object.

    Parameters
    ----------
    source: str
    target: str
    type: str
    visualization: Optional[Dict[str, Any]]

    """

    source: str = Field(
        ...,
        description="Name of the source entity which send data.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    target: str = Field(
        ...,
        description="Name of the target entity which receives data.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    type: str = Field(
        ...,
        description="Type of relationship between the `source` key and the `target` key.</p> There is only one option;  `connection`.",
    )
    visualization: Optional[Dict[str, Any]] = Field(None, description="For internal use only.")


class MapShiftGet(DataModelBase):
    """
    MapShiftGet object.

    Parameters
    ----------
    map_names: Optional[List[str]]

    """

    map_names: Optional[List[str]] = Field(
        None,
        description="Unique identifier name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a> that contains the wanted Shift data.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class Metric(DataModelBase):
    """
    Metric object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]

    """

    asset_name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class MetricCreate(DataModelBase):
    """
    MetricCreate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    data_type_version: Optional[str]
    display_unit: Optional[str]
    name: Optional[str]
    semantic_type_name: Optional[str]
    semantic_type_properties: Optional[Dict[str, Any]]
    title: Optional[str]
    write: Optional[bool]

    """

    data_type_name: Optional[str] = Field(
        None,
        description="Type of data being recorded to this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> there are 13 types of data type options; `raw.boolean`, `raw.dynacard`, `raw.float32`, `raw.float64`, `raw.int8`, `raw.int16`, `raw.int32`, `raw.int64`, `raw.uint8`, `raw.uint16`, `raw.uint32`, `raw.uint64` and `raw.text`.",
    )
    data_type_version: Optional[str] = Field(
        None, description="Version of the data type.</p> For example `2.0.0`."
    )
    display_unit: Optional[str] = Field(
        None,
        description="Units for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This can be anything to describe the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> units. For example `Amp`, `Hz`, `॰F`, etc.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    semantic_type_name: Optional[str] = Field(
        None,
        description="Type of sensor that is streaming data to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. Depending on the options chosen, there may be more properties available which will be saved to the `SemanticTypeProperties` parameters.</p> There are currently 28 Semantic Type Names available; `None`, `Accelerometer`, `Current`, `Dynacard`, `Event Flow Rate`, `Force`, `Frequency`, `Gas Flow Rate`, `Gas Volume`, `Humidity`, `Latitude`, `Length`, `Location`, `Longitude`, `Mass`, `Power`, `Pressure`, `Relative Humidity`, `State`, `Temperature`, `Time Date`, `Time Span`, `Torque`, `Velocity`, `Vibration`, `Voltage`, `Volume`, `Volume Flow Rate`.",
    )
    semantic_type_properties: Optional[Dict[str, Any]] = Field(
        None,
        description="Additional properties depending on the selected `SemanticTypeName` parameter chosen.</p> For example; if the semantic type chosen is `temperature`, then there will be an additional parameter in semantic type properties for `temperature unit` where fahrenheit or celsius can be chosen.",
    )
    title: Optional[str] = Field(
        None,
        description="Display name (title) for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    write: Optional[bool] = Field(
        None,
        description="Defines whether this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> is read only (`false`) or read/write (`true`).</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> feature is used on this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>, then this parameter must be `true`.",
    )


class MetricExtraFieldComputation(DataModelBase):
    """
    MetricExtraFieldComputation object.

    Parameters
    ----------
    agg: Optional[str]
    end_time: Optional[str]
    start_time: Optional[str]

    """

    agg: Optional[str] = Field(
        None,
        description="Perform mathematical calculations on a group of data defined by the 'starttime' and 'endtime' keys.</p> For numerical data the mathematical options available are; `count`, `mean`, `sum`, `max` and `min`.</p> For text based data the mathematical options available are; `count`.",
    )
    end_time: Optional[str] = Field(
        None,
        description="The end time for the time range of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metrics</a> related to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to be used by the `agg` key calculations.",
    )
    start_time: Optional[str] = Field(
        None,
        description="The start time for the time range of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metrics</a> related to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to be used by the `agg` key calculations.",
    )


class MetricUpdate(DataModelBase):
    """
    MetricUpdate object.

    Parameters
    ----------
    data_type_name: Optional[str]
    data_type_version: Optional[str]
    display_unit: Optional[str]
    semantic_type_name: Optional[str]
    semantic_type_properties: Optional[Dict[str, Any]]
    title: Optional[str]
    write: Optional[bool]

    """

    data_type_name: Optional[str] = Field(
        None,
        description="Type of data being recorded to this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> there are 13 types of data type options; `raw.boolean`, `raw.dynacard`, `raw.float32`, `raw.float64`, `raw.int8`, `raw.int16`, `raw.int32`, `raw.int64`, `raw.uint8`, `raw.uint16`, `raw.uint32`, `raw.uint64` and `raw.text`.",
    )
    data_type_version: Optional[str] = Field(
        None, description="Version of the data type.</p> For example `2.0.0`."
    )
    display_unit: Optional[str] = Field(
        None,
        description="Units for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This can be anything to describe the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> units. For example `Amp`, `Hz`, `॰F`, etc.",
        max_length=64,
    )
    semantic_type_name: Optional[str] = Field(
        None,
        description="Type of sensor that is streaming data to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. Depending on the options chosen, there may be more properties available which will be saved to the `SemanticTypeProperties` parameters.</p> There are currently 28 Semantic Type Names available; `None`, `Accelerometer`, `Current`, `Dynacard`, `Event Flow Rate`, `Force`, `Frequency`, `Gas Flow Rate`, `Gas Volume`, `Humidity`, `Latitude`, `Length`, `Location`, `Longitude`, `Mass`, `Power`, `Pressure`, `Relative Humidity`, `State`, `Temperature`, `Time Date`, `Time Span`, `Torque`, `Velocity`, `Vibration`, `Voltage`, `Volume`, `Volume Flow Rate`.",
    )
    semantic_type_properties: Optional[Dict[str, Any]] = Field(
        None,
        description="Additional properties depending on the selected `SemanticTypeName` parameter chosen.</p> For example; if the semantic type chosen is `temperature`, then there will be an additional parameter in semantic type properties for `temperature unit` where fahrenheit or celsius can be chosen.",
    )
    title: Optional[str] = Field(
        None,
        description="Display name (title) for this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    write: Optional[bool] = Field(
        None,
        description="Defines whether this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> is read only (`false`) or read/write (`true`).</p> If the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> feature is used on this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>, then this parameter must be `true`.",
    )


class OEECalculation(DataModelBase):
    """
    OEECalculation object.

    Parameters
    ----------
    good_units: Optional[int]
    ideal_cycle_time: Optional[int]
    planned_production_time: Optional[int]
    run_time: Optional[int]
    total_units: Optional[int]

    """

    good_units: Optional[int] = Field(
        None, description="Total number of goods produced pieces, NOT including the defective ones."
    )
    ideal_cycle_time: Optional[int] = Field(
        None,
        description="Fastest cycle time that your process can achieve in optimal circumstances with no stop time. Make sure all time units use the same baseline such as seconds, minutes, hours or days.",
    )
    planned_production_time: Optional[int] = Field(
        None,
        description="Amount of time the process is planned to be running. Make sure all time units use the same baseline such as seconds, minutes, hours or days.",
    )
    run_time: Optional[int] = Field(
        None,
        description="Total time that the process was running (not stopped) during the Planned Production Time. Make sure all time units use the same baseline such as seconds, minutes, hours or days.",
    )
    total_units: Optional[int] = Field(
        None, description="Total number of produced pieces, INCLUDING the defective ones"
    )


class OEEThresholds(DataModelBase):
    """
    OEEThresholds object.

    Parameters
    ----------
    critical_alarm: Optional[int]
    target: Optional[int]
    warning_alarm: Optional[int]

    """

    critical_alarm: Optional[int] = Field(
        None,
        description='Critical alarm threshold value (in percentage) for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> at the nominated timestamp.',
    )
    target: Optional[int] = Field(
        None,
        description='Target OEE value (in percentage) for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> at the nominated timestamp.',
    )
    warning_alarm: Optional[int] = Field(
        None,
        description='Warning alarm threshold value (in percentage) for the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> at the nominated timestamp.',
    )


class ParameterAppVersion(DataModelBase):
    """
    ParameterAppVersion object.

    Parameters
    ----------
    name: Optional[str]
    version: Optional[str]

    """

    name: Optional[str] = None
    version: Optional[str] = None


class ParameterList(DataModelBase):
    """
    ParameterList object.

    Parameters
    ----------
    apps: Optional[List[ParameterAppVersion]]
    asset_names: Optional[List[str]]

    """

    apps: Optional[List[ParameterAppVersion]] = Field(
        None, description="An array of App/Version identifiers"
    )
    asset_names: Optional[List[str]] = Field(
        None,
        description="An array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve the last <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class ParameterUpdate(DataModelBase):
    """
    ParameterUpdate object.

    Parameters
    ----------
    payload: Dict[str, Any]

    """

    payload: Dict[str, Any]


class ProcessesList(DataModelBase):
    """
    ProcessesList object.

    Parameters
    ----------
    alarm_statuses: Optional[List[str]]
    asset_name: Optional[str]
    mode: Optional[str]

    """

    alarm_statuses: Optional[List[str]] = None
    asset_name: Optional[str] = None
    mode: Optional[str] = None


class ProductionInfo(DataModelBase):
    """
    ProductionInfo object.

    Parameters
    ----------
    expected_end_at: Optional[datetime]
    expected_start_at: Optional[datetime]
    sku: Optional[str]

    """

    expected_end_at: Optional[datetime] = Field(
        None,
        description='End time for the production in ISO 8601 UTC date/time format. Example; "2022-07-08T08:41:01.657916Z".',
    )
    expected_start_at: Optional[datetime] = Field(
        None,
        description='Start time for the production in ISO 8601 UTC date/time format. Example; "2022-07-08T08:41:01.657916Z".',
    )
    sku: Optional[str] = Field(
        None,
        description="Display text for the production information in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class RecommendationAccept(DataModelBase):
    """
    RecommendationAccept object.

    Parameters
    ----------
    message: Optional[str]

    """

    message: Optional[str] = None


class RecommendationAlarm(DataModelBase):
    """
    RecommendationAlarm object.

    Parameters
    ----------
    alarm_type_name: Optional[str]
    description: Optional[str]
    payload: Optional[Dict[str, Any]]
    severity: Optional[int]
    solution: Optional[str]
    source_asset_names: Optional[List[str]]
    tags: Optional[List[str]]
    target_asset_name: Optional[str]
    title: Optional[str]

    """

    alarm_type_name: Optional[str] = None
    description: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None
    severity: Optional[int] = None
    solution: Optional[str] = None
    source_asset_names: Optional[List[str]] = None
    tags: Optional[List[str]] = None
    target_asset_name: Optional[str] = None
    title: Optional[str] = None


class RecommendationClustering(DataModelBase):
    """
    RecommendationClustering object.

    Parameters
    ----------
    end_date: datetime
    resource_names: Optional[List[str]]
    start_date: datetime
    states: Optional[List[str]]
    time_bucket: str
    types: Optional[List[str]]

    """

    end_date: datetime
    resource_names: Optional[List[str]] = None
    start_date: datetime
    states: Optional[List[str]] = None
    time_bucket: str
    types: Optional[List[str]] = None


class RecommendationControlChange(DataModelBase):
    """
    RecommendationControlChange object.

    Parameters
    ----------
    asset_name: Optional[str]
    expiration_date: Optional[str]
    metric_name: Optional[str]
    payload: Optional[Dict[str, Any]]
    retry: Optional[int]
    timeout: Optional[int]

    """

    asset_name: Optional[str] = None
    expiration_date: Optional[str] = None
    metric_name: Optional[str] = None
    payload: Optional[Dict[str, Any]] = None
    retry: Optional[int] = None
    timeout: Optional[int] = None


class RecommendationCreateLog(DataModelBase):
    """
    RecommendationCreateLog object.

    Parameters
    ----------
    message: Optional[str]

    """

    message: Optional[str] = None


class RecommendationDataLabelMetric(DataModelBase):
    """
    RecommendationDataLabelMetric object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]

    """

    asset_name: Optional[str] = None
    name: Optional[str] = None


class RecommendationExtraField(DataModelBase):
    """
    RecommendationExtraField object.

    Parameters
    ----------
    name: Optional[str]
    since: Optional[str]
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    name: Optional[str] = None
    since: Optional[str] = None
    states: Optional[List[str]] = None
    types: Optional[List[str]] = None


class RecommendationLast(DataModelBase):
    """
    RecommendationLast object.

    Parameters
    ----------
    resources: Optional[List[str]]
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    resources: Optional[List[str]] = None
    states: Optional[List[str]] = None
    types: Optional[List[str]] = None


class RecommendationList(DataModelBase):
    """
    RecommendationList object.

    Parameters
    ----------
    ids: Optional[List[str]]
    resources: Optional[List[str]]
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    ids: Optional[List[str]] = None
    resources: Optional[List[str]] = None
    states: Optional[List[str]] = None
    types: Optional[List[str]] = None


class RecommendationRange(DataModelBase):
    """
    RecommendationRange object.

    Parameters
    ----------
    end_date: Optional[datetime]
    resources: Optional[List[str]]
    start_date: Optional[datetime]
    states: Optional[List[str]]
    types: Optional[List[str]]

    """

    end_date: Optional[datetime] = None
    resources: Optional[List[str]] = None
    start_date: Optional[datetime] = None
    states: Optional[List[str]] = None
    types: Optional[List[str]] = None


class RecommendationReject(DataModelBase):
    """
    RecommendationReject object.

    Parameters
    ----------
    message: Optional[str]

    """

    message: Optional[str] = None


class ReferenceMetric(DataModelBase):
    """
    ReferenceMetric object.

    Parameters
    ----------
    asset_name: str
    metric_name: str

    """

    asset_name: str = Field(
        ...,
        description="The <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.",
    )
    metric_name: str = Field(
        ...,
        description="The <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.",
    )


class ResponsibleFor(DataModelBase):
    """
    ResponsibleFor object.

    Parameters
    ----------
    name: Optional[str]
    type: Optional[str]

    """

    name: Optional[str] = Field(
        None,
        description="Unique identifier of an existing name for either a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    type: Optional[str] = Field(
        None,
        description="Type of responsible. Only one parameter can be selected.</p> There are two parameter options; `asset` or `map`.",
    )


class RuleAction(DataModelBase):
    """
    RuleAction object.

    Parameters
    ----------
    metric_name: Optional[str]
    target_asset_name: Optional[str]
    type: Optional[str]

    """

    metric_name: Optional[str] = Field(None, max_length=64)
    target_asset_name: Optional[str] = Field(None, max_length=64)
    type: Optional[str] = Field(None, max_length=64)


class RuleInput(DataModelBase):
    """
    RuleInput object.

    Parameters
    ----------
    asset_name: Optional[str]
    metric_name: Optional[str]

    """

    asset_name: Optional[str] = Field(None, max_length=64)
    metric_name: Optional[str] = Field(None, max_length=64)


class RuleValidate(DataModelBase):
    """
    RuleValidate object.

    Parameters
    ----------
    script: Optional[str]

    """

    script: Optional[str] = None


class RulesEngineCSV(DataModelBase):
    """
    RulesEngineCSV object.

    Parameters
    ----------
    url: Optional[str]

    """

    url: Optional[str] = None


class ScheduleConfig(DataModelBase):
    """
    ScheduleConfig object.

    Parameters
    ----------
    expression: Optional[str]

    """

    expression: Optional[str] = None


class SecretCreate(DataModelBase):
    """
    SecretCreate object.

    Parameters
    ----------
    name: str
    value: str

    """

    name: str = Field(..., max_length=32)
    value: str


class ShiftInfo(DataModelBase):
    """
    ShiftInfo object.

    Parameters
    ----------
    end_at: Optional[datetime]
    name: Optional[str]
    start_at: Optional[datetime]

    """

    end_at: Optional[datetime] = Field(
        None,
        description='End time for the shift in ISO 8601 UTC date/time format. Example; "2022-07-08T08:41:01.657916Z".',
    )
    name: Optional[str] = Field(
        None,
        description="Display text for the shift information in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> You can use any character, numeric, space and special character in this parameter.",
    )
    start_at: Optional[datetime] = Field(
        None,
        description='Start time for the shift in ISO 8601 UTC date/time format. Example; "2022-07-08T08:41:01.657916Z".',
    )


class StorageCreate(DataModelBase):
    """
    StorageCreate object.

    Parameters
    ----------
    asset_name: str
    data_type: str
    id: Optional[str]
    name: str
    payload: Dict[str, Any]
    source: Optional[str]
    target: Optional[str]
    timestamp: datetime
    trace_id: Optional[str]

    """

    asset_name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    data_type: str = Field(
        ...,
        description="Data type of the payload values. This should match the data type that is defined in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> used in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair defined in the `name` parameter.",
        max_length=64,
    )
    id: Optional[str] = None
    name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    payload: Dict[str, Any] = Field(
        ...,
        description="The actual payload of information saved for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> The standard payload will look like this</p>  <blockquote>{</br>&nbsp;&nbsp;\"payload\": {</br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\"value\": 88</br>&nbsp;&nbsp;&nbsp;&nbsp;}</br>}</blockquote>",
    )
    source: Optional[str] = Field(
        None,
        description="Name of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-apps/' target='_blank'>Kelvin App</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-bridges/' target='_blank'>Kelvin Bridge</a> that has collected the data and transmitted it to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=256,
    )
    target: Optional[str] = Field(
        None,
        description="This is not used for any <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> functions and can be defined by the user for custom information.",
        max_length=256,
    )
    timestamp: datetime = Field(
        ...,
        description='Time when the payload data was created at the source in ISO 8601 UTC date/time format. Example; "2022-07-08T08:41:01.657916Z".',
        example="2022-01-13T12:00:00.000000Z",
    )
    trace_id: Optional[str] = Field(
        None, description="This is for internal purposes and is the same as the `id`."
    )


class StorageDelete(DataModelBase):
    """
    StorageDelete object.

    Parameters
    ----------
    end_time: datetime
    selectors: List[DeleteSelector]
    start_time: datetime

    """

    end_time: datetime = Field(
        ...,
        description="End time for the recorded time to delete data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )
    selectors: List[DeleteSelector] = Field(
        ...,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs that you want to delete a range of historian data.",
    )
    start_time: datetime = Field(
        ...,
        description="Start time for the recorded time to delete data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )


class Order(Enum):
    ASC = "ASC"
    DESC = "DESC"


class StorageSelector(DataModelBase):
    """
    StorageSelector object.

    Parameters
    ----------
    asset_name: str
    fields: Optional[List[str]]
    name: str

    """

    asset_name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    fields: Optional[List[str]] = Field(
        None,
        description="Array of wanted keys that are recorded in the payload. Normally this will be `value`.</p> If there are other unique keys/value pairs in the payload, then you can create a list of all keys to retrieve the values. e.g. 'value,key2,key3'. If the key does not exist in the stored payload, that key will return with a value `null`.",
    )
    name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )


class StorageUpdate(DataModelBase):
    """
    StorageUpdate object.

    Parameters
    ----------
    asset_name: Optional[str]
    name: Optional[str]
    title: Optional[str]

    """

    asset_name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    title: Optional[str] = Field(
        None,
        description="New display name (title) for this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class SymbolCreate(DataModelBase):
    """
    SymbolCreate object.

    Parameters
    ----------
    name: str
    payload: str
    symbol_type: str
    title: str

    """

    name: str = Field(
        ...,
        description="Unique identifier name for the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-editors/kelvin-maps-process-map-editor/?h=symbol#symbol-library' target='_blank'>Symbol</a>. This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    payload: str = Field(
        ...,
        description='Contains the image information usually in SVG format.</p> Example : ""<svg viewBox=\\"0 0 40 40\\" xmlns=\\"http://www.w3.org/2000/svg\\"><defs><style>.c{stroke-width:.71px;fill:none;stroke:#fff;stroke-miterlimit:10}</style></defs><g fill=\\"none\\" fill-rule=\\"evenodd\\"><path d=\\"M4.2 ..... 93-1.93Z\\"/></g></svg>"',
    )
    symbol_type: str = Field(
        ...,
        description="Category name where the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-editors/kelvin-maps-process-map-editor/?h=symbol#symbol-library' target='_blank'>Symbol</a> will be located in the selection sidebar.</p> You can use any character, numeric, space and special character in this parameter. All characters will be automatically converted to upper case when displaved in <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.",
    )
    title: str = Field(
        ...,
        description="Display name (title) for the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-editors/kelvin-maps-process-map-editor/?h=symbol#symbol-library' target='_blank'>Symbol</a>. This is a friendly name displayed in lists and in any references.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class SymbolUpdate(DataModelBase):
    """
    SymbolUpdate object.

    Parameters
    ----------
    payload: Optional[str]
    symbol_type: Optional[str]
    title: Optional[str]

    """

    payload: Optional[str] = Field(
        None,
        description='Contains the image information usually in SVG format.</p> Example : ""<svg viewBox=\\"0 0 40 40\\" xmlns=\\"http://www.w3.org/2000/svg\\"><defs><style>.c{stroke-width:.71px;fill:none;stroke:#fff;stroke-miterlimit:10}</style></defs><g fill=\\"none\\" fill-rule=\\"evenodd\\"><path d=\\"M4.2 ..... 93-1.93Z\\"/></g></svg>"',
    )
    symbol_type: Optional[str] = Field(
        None,
        description="Category name where the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-editors/kelvin-maps-process-map-editor/?h=symbol#symbol-library' target='_blank'>Symbol</a> will be located in the selection sidebar.</p> You can use any character, numeric, space and special character in this parameter. All characters will be automatically converted to upper case when displaved in <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.",
    )
    title: Optional[str] = Field(
        None,
        description="Display name (title) for the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-maps/kelvin-maps-editors/kelvin-maps-process-map-editor/?h=symbol#symbol-library' target='_blank'>Symbol</a>. This is a friendly name displayed in lists and in any references.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class TeamMember(DataModelBase):
    """
    TeamMember object.

    Parameters
    ----------
    email: Optional[str]
    name: Optional[str]
    phone_country_code: Optional[str]
    phone_number: Optional[str]
    responsible_for: Optional[ResponsibleFor]
    role: Optional[str]

    """

    email: Optional[str] = Field(
        None,
        description="Email address for the team member.</p> You can use any character, numeric, space and special character in this parameter.",
    )
    name: Optional[str] = Field(
        None,
        description="Display name for the team member.</p> You can use any character, numeric, space and special character in this parameter.",
    )
    phone_country_code: Optional[str] = Field(
        None,
        description="Country code for the team member's phone number.</p> You can use any character, numeric, space and special character in this parameter.",
    )
    phone_number: Optional[str] = Field(
        None,
        description="Phone number for the team member.</p> You can use any character, numeric, space and special character in this parameter.",
    )
    responsible_for: Optional[ResponsibleFor] = None
    role: Optional[str] = Field(
        None,
        description="Role for the team member.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class UserSettingUpdate(DataModelBase):
    """
    UserSettingUpdate object.

    Parameters
    ----------
    payload: Optional[Dict[str, Any]]

    """

    payload: Optional[Dict[str, Any]] = None


class View2D(DataModelBase):
    """
    View2D object.

    Parameters
    ----------
    image_model: Optional[str]
    x: Optional[float]
    y: Optional[float]

    """

    image_model: Optional[str] = Field(
        None,
        description='A http(s) URL link to an SVG image used to visually display your <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.',
    )
    x: Optional[float] = Field(
        None,
        description="This is the x coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )
    y: Optional[float] = Field(
        None,
        description="This is the y coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )


class View3D(DataModelBase):
    """
    View3D object.

    Parameters
    ----------
    image_model: Optional[str]
    x: Optional[float]
    y: Optional[float]
    z: Optional[float]

    """

    image_model: Optional[str] = Field(
        None,
        description='A http(s) URL link to a GLB model used to visually display your <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.',
    )
    x: Optional[float] = Field(
        None,
        description="This is the x coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )
    y: Optional[float] = Field(
        None,
        description="This is the y coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )
    z: Optional[float] = Field(
        None,
        description="This is the z coordinate for the placement of the model on the page.</p> The default is 0.</p> This is important as it will affect the coordinates embedded in Kelvin Alarms to highlight alarm locations on the model.",
    )


class Visualization(DataModelBase):
    """
    Visualization object.

    Parameters
    ----------
    view_2d: Optional[View2D]
    view_3d: Optional[View3D]

    """

    view_2d: Optional[View2D] = None
    view_3d: Optional[View3D] = None


class WireguardPeerCreate(DataModelBase):
    """
    WireguardPeerCreate object.

    Parameters
    ----------
    allowed_ips: Optional[List[str]]
    endpoint: Optional[str]
    name: str
    public_key: Optional[str]
    title: str
    type: str

    """

    allowed_ips: Optional[List[str]] = None
    endpoint: Optional[str] = None
    name: str
    public_key: Optional[str] = None
    title: str
    type: str


class WireguardPeerUpdate(DataModelBase):
    """
    WireguardPeerUpdate object.

    Parameters
    ----------
    allowed_ips: Optional[List[str]]
    endpoint: Optional[str]
    public_key: Optional[str]
    title: str
    type: str

    """

    allowed_ips: Optional[List[str]] = None
    endpoint: Optional[str] = None
    public_key: Optional[str] = None
    title: str
    type: str


class WireguardTunnelCreate(DataModelBase):
    """
    WireguardTunnelCreate object.

    Parameters
    ----------
    keep_alive: Optional[int]
    wireguard_peer: str

    """

    keep_alive: Optional[int] = None
    wireguard_peer: str


class WorkloadDeploy(DataModelBase):
    """
    WorkloadDeploy object.

    Parameters
    ----------
    acp_name: str
    app_name: str
    app_version: Optional[str]
    name: Optional[str]
    payload: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    acp_name: str
    app_name: str
    app_version: Optional[str] = None
    name: Optional[str] = Field(None, max_length=32)
    payload: Optional[Dict[str, Any]] = None
    title: Optional[str] = Field(None, max_length=64)


class WorkloadStatusUpdateValues(DataModelBase):
    """
    WorkloadStatusUpdateValues object.

    Parameters
    ----------
    message: Optional[str]
    name: Optional[str]
    state: Optional[str]
    warnings: Optional[List[str]]

    """

    message: Optional[str] = None
    name: Optional[str] = None
    state: Optional[str] = None
    warnings: Optional[List[str]] = None


class ACPMetadataBulkCreate(BaseModelRoot[ACPMetadataBulkCreateItem]):
    """
    ACPMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[ACPMetadataBulkCreateItem]

    """

    __root__: List[ACPMetadataBulkCreateItem]


class ACPMetadataBulkDelete(BaseModelRoot[ACPMetadataBulkDeleteItem]):
    """
    ACPMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[ACPMetadataBulkDeleteItem]

    """

    __root__: List[ACPMetadataBulkDeleteItem]


class ACPSetting(DataModelBase):
    """
    ACPSetting object.

    Parameters
    ----------
    auto_update: Optional[ACPSettingAutoUpdate]
    metrics: Optional[ACPSettingMetrics]
    sync: Optional[ACPSettingSync]

    """

    auto_update: Optional[ACPSettingAutoUpdate] = None
    metrics: Optional[ACPSettingMetrics] = None
    sync: Optional[ACPSettingSync] = None


class ACPStatusUpdate(DataModelBase):
    """
    ACPStatusUpdate object.

    Parameters
    ----------
    configs: Optional[List[str]]
    node: Optional[ACPStatusUpdateValues]
    pending_workloads: Optional[List[WorkloadStatusUpdateValues]]
    workloads: Optional[List[WorkloadStatusUpdateValues]]

    """

    configs: Optional[List[str]] = None
    node: Optional[ACPStatusUpdateValues] = None
    pending_workloads: Optional[List[WorkloadStatusUpdateValues]] = None
    workloads: Optional[List[WorkloadStatusUpdateValues]] = None


class AlarmConditionNotificationsUserSetting(DataModelBase):
    """
    AlarmConditionNotificationsUserSetting object.

    Parameters
    ----------
    alarm_severity: Optional[List[int]]
    alarm_type_name: Optional[List[str]]
    asset_name: Optional[List[str]]
    name: Optional[str]
    targets: Optional[List[AlarmConditionTargetNotificationsUserSetting]]

    """

    alarm_severity: Optional[List[int]] = None
    alarm_type_name: Optional[List[str]] = None
    asset_name: Optional[List[str]] = None
    name: Optional[str] = None
    targets: Optional[List[AlarmConditionTargetNotificationsUserSetting]] = None


class AlarmCreate(DataModelBase):
    """
    AlarmCreate object.

    Parameters
    ----------
    alarm_type_name: str
    created_by: CreatedBy
    custom_identifier: Optional[str]
    description: Optional[str]
    payload: Optional[Dict[str, Any]]
    severity: Optional[int]
    solution: Optional[str]
    source_asset_names: List[str]
    tags: Optional[List[str]]
    target_asset_name: str
    title: str

    """

    alarm_type_name: str = Field(
        ...,
        description="The Alarm Type that is associated with this alarm. <i>Note: Before making a Kelvin Alarm the Kelvin Alarm Type and a Kelvin Alarm Class must exist in the Kelvin Platform. These can be created with API commands.</i>",
    )
    created_by: CreatedBy
    custom_identifier: Optional[str] = Field(
        None, description="An option to tag the alarm with a custom identifying string"
    )
    description: Optional[str] = Field(
        None, description="A summary description of what the alarm is about."
    )
    payload: Optional[Dict[str, Any]] = None
    severity: Optional[int] = Field(
        None,
        description="How serious the alarm is in a rating from 1 (most severe) to 5 (least severe).",
    )
    solution: Optional[str] = Field(
        None,
        description="Any tips to help users solve the alarm. <i>It is recommended to be as detailed as possible here.</i>",
    )
    source_asset_names: List[str] = Field(
        ...,
        description="A Name of a Kelvin Asset, Kelvin Component, Kelvin Part or Kelvin Sensor that actually generated the alarm. e.g. A Kelvin Sensor going over maximum is related to the health of a Kelvin Component.",
    )
    tags: Optional[List[str]] = None
    target_asset_name: str = Field(
        ...,
        description="A name of a Kelvin Asset, Kelvin Component, Kelvin Part or Kelvin Sensor that the alarm will be associated with. <i>Note: do not confuse this with the Display Name.</i>",
    )
    title: str = Field(..., description="The title of the alarm that will be displayed.")


class AlarmList(DataModelBase):
    """
    AlarmList object.

    Parameters
    ----------
    acknowledged_at_end: Optional[datetime]
    acknowledged_at_start: Optional[datetime]
    acknowledged_by: Optional[List[str]]
    alarm_class_names: Optional[List[str]]
    alarm_ids: Optional[List[str]]
    alarm_severities: Optional[List[int]]
    alarm_statuses: Optional[List[str]]
    alarm_type_names: Optional[List[str]]
    asset_class_names: Optional[List[str]]
    asset_include_children: Optional[bool]
    asset_type_names: Optional[List[str]]
    created_at_end: Optional[datetime]
    created_at_start: Optional[datetime]
    created_by: Optional[List[CreatedBy]]
    custom_identifiers: Optional[List[str]]
    resolved_at_end: Optional[datetime]
    resolved_at_start: Optional[datetime]
    resolved_by: Optional[List[str]]
    search: Optional[List[str]]
    tags: Optional[List[str]]
    target_asset_names: Optional[List[str]]

    """

    acknowledged_at_end: Optional[datetime] = None
    acknowledged_at_start: Optional[datetime] = None
    acknowledged_by: Optional[List[str]] = None
    alarm_class_names: Optional[List[str]] = None
    alarm_ids: Optional[List[str]] = None
    alarm_severities: Optional[List[int]] = None
    alarm_statuses: Optional[List[str]] = None
    alarm_type_names: Optional[List[str]] = None
    asset_class_names: Optional[List[str]] = None
    asset_include_children: Optional[bool] = None
    asset_type_names: Optional[List[str]] = None
    created_at_end: Optional[datetime] = None
    created_at_start: Optional[datetime] = None
    created_by: Optional[List[CreatedBy]] = None
    custom_identifiers: Optional[List[str]] = None
    resolved_at_end: Optional[datetime] = None
    resolved_at_start: Optional[datetime] = None
    resolved_by: Optional[List[str]] = None
    search: Optional[List[str]] = None
    tags: Optional[List[str]] = None
    target_asset_names: Optional[List[str]] = None


class AlarmNotificationsUserSetting(DataModelBase):
    """
    AlarmNotificationsUserSetting object.

    Parameters
    ----------
    conditions: Optional[List[AlarmConditionNotificationsUserSetting]]
    enabled: Optional[bool]

    """

    conditions: Optional[List[AlarmConditionNotificationsUserSetting]] = None
    enabled: Optional[bool] = None


class AnonymousTemplate(DataModelBase):
    """
    AnonymousTemplate object.

    Parameters
    ----------
    entity_type_name: Optional[str]
    failure_detection: Optional[FailureDetectionTemplate]
    properties: Optional[List[AssetTemplateProperties]]

    """

    entity_type_name: Optional[str] = Field(
        None,
        description='Entity type that is linked to this new Kelvin Template.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    failure_detection: Optional[FailureDetectionTemplate] = None
    properties: Optional[List[AssetTemplateProperties]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )


class AssetOEE(DataModelBase):
    """
    AssetOEE object.

    Parameters
    ----------
    asset_name: Optional[str]
    oee_calculation: Optional[OEECalculation]
    oee_thresholds: Optional[OEEThresholds]

    """

    asset_name: Optional[str] = Field(
        None,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    oee_calculation: Optional[OEECalculation] = None
    oee_thresholds: Optional[OEEThresholds] = None


class AssetTemplateHierarchy(DataModelBase):
    """
    AssetTemplateHierarchy object.

    Parameters
    ----------
    from_template_name: Optional[str]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    metrics: Optional[List[AssetMetricItem]]
    template: Optional[AnonymousTemplate]
    title: Optional[str]
    visualization: Optional[Visualization]

    """

    from_template_name: Optional[str] = Field(
        None,
        description="Name of the Kelvin Template to copy its full <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> to this location.</p> If this parameter is used, no other parameter in this structure is required.",
    )
    hierarchy: Optional[List[AssetTemplateHierarchy]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Component</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Part</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensor</a> in the Kelvin Template <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p>\tThis can be changed by the user when adding the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#kelvin-templates' target='_blank'>Kelvin Template</a> as a new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    template: Optional[AnonymousTemplate] = None
    title: Optional[str] = Field(
        None,
        description="Default display name (title) for this property in the new Kelvin Template. This is a friendly name displayed in lists and in references.</p> You can use any character, numeric, space and special character in this parameter.</p> This is shown as an example Display Name parameter field.</p> If you use `from_template_name parameter` this parameter is not required.",
    )
    visualization: Optional[Visualization] = None


class AssetTemplateUpdate(DataModelBase):
    """
    AssetTemplateUpdate object.

    Parameters
    ----------
    asset_type_name: Optional[str]
    description: Optional[str]
    entity_type_name: Optional[str]
    failure_detection: Optional[FailureDetectionTemplate]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    hints: Optional[Dict[str, Any]]
    image_url: Optional[str]
    metrics: Optional[List[AssetMetricItem]]
    properties: Optional[List[AssetTemplateProperties]]
    title: Optional[str]
    visualization: Optional[Visualization]

    """

    asset_type_name: Optional[str] = Field(
        None,
        description='The name (not the Display Name / Title) of the default <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> that will be selected.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    description: Optional[str] = Field(
        None, description="A full description of the Kelvin Template.", max_length=512
    )
    entity_type_name: Optional[str] = Field(
        None,
        description='Entity type that is linked to this new Kelvin Template.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
        max_length=64,
    )
    failure_detection: Optional[FailureDetectionTemplate] = None
    hierarchy: Optional[List[AssetTemplateHierarchy]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the Kelvin Template <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    hints: Optional[Dict[str, Any]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    image_url: Optional[str] = Field(
        None,
        description="A http(s) URL link to an image to visually display your template picture next to the description.</p> The file can be in any web-compatible format including jpg, png, gif, animated gif and apng. Even though any size is allowed as it will be automatically resized, it is advised to keep it below 400 x 400 px.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.",
    )
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    properties: Optional[List[AssetTemplateProperties]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    title: Optional[str] = Field(
        None,
        description="New display name (title) for the Kelvin Template. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class ClusterCreate(DataModelBase):
    """
    ClusterCreate object.

    Parameters
    ----------
    info: Optional[Dict[str, Any]]
    kelvin_info: Optional[Dict[str, Any]]
    kubeconfig: Optional[str]
    location: Optional[ClusterLocationItem]
    name: Optional[str]
    network_info: Optional[Dict[str, Any]]
    system_info: Optional[Dict[str, Any]]
    title: Optional[str]

    """

    info: Optional[Dict[str, Any]] = None
    kelvin_info: Optional[Dict[str, Any]] = None
    kubeconfig: Optional[str] = None
    location: Optional[ClusterLocationItem] = None
    name: Optional[str] = None
    network_info: Optional[Dict[str, Any]] = None
    system_info: Optional[Dict[str, Any]] = None
    title: Optional[str] = None


class ControlChangeUpload(DataModelBase):
    """
    ControlChangeUpload object.

    Parameters
    ----------
    requests: Optional[List[ControlChangeUploadRequest]]
    statuses: Optional[List[ControlChangeUploadStatus]]

    """

    requests: Optional[List[ControlChangeUploadRequest]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> requests on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.",
    )
    statuses: Optional[List[ControlChangeUploadStatus]] = Field(
        None,
        description="An array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-control-change/' target='_blank'>Kelvin Control Change</a> statuses on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-nodes/' target='_blank'>Kelvin Node</a>.",
    )


class DataLabelCluster(DataModelBase):
    """
    DataLabelCluster object.

    Parameters
    ----------
    end_date: Optional[datetime]
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    start_date: Optional[datetime]
    time_bucket: Optional[str]

    """

    end_date: Optional[datetime] = Field(
        None,
        description="Timestamp for the end of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).</p> If the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Labels</a> is a snapshot in time, the start_time and end_time can be the same.",
    )
    label_names: Optional[List[str]] = Field(
        None,
        description="Filter the returned results based on an Array of Label names.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> Each Label name will be filtered using the `OR` operator.",
    )
    metrics: Optional[List[Metric]] = Field(
        None,
        description="Filter the returned results based on an array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs.</p> Note : If you use this filter parameter, you can not just filter on a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. It must be the pair together.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair names will be filtered using the `OR` operator.",
    )
    start_date: Optional[datetime] = Field(
        None,
        description="Timestamp for the start of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).",
    )
    time_bucket: Optional[str] = Field(
        None,
        description="Time window to group and aggregate the occurrence of Labels within the defined time buckets.</p> Bucket time options available can be found at https://golang.org/pkg/time/#ParseDuration. For example '1h', '1m' or '2h45m'.",
    )


class DataLabelCreate(DataModelBase):
    """
    DataLabelCreate object.

    Parameters
    ----------
    confidence: Optional[int]
    description: Optional[str]
    end_date: datetime
    info: Optional[Dict[str, Any]]
    label_name: str
    metrics: List[Metric]
    source: DataLabelSource
    start_date: datetime
    validation: Optional[bool]

    """

    confidence: Optional[int] = Field(
        None,
        description="Option  for Machine Learning systems to save the confidence results of any model's output",
    )
    description: Optional[str] = Field(
        None,
        description="Any type of description that adequately explains this <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> entry. In a practical sense this description could be used in a dashboard for the operators to understand this particular <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a>.",
        max_length=256,
    )
    end_date: datetime = Field(
        ...,
        description="Timestamp for the end of a time range for which the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).</p> If the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> is a snapshot in time, the start_time and end_time can be the same.",
    )
    info: Optional[Dict[str, Any]] = Field(
        None,
        description="A JSON object with any key/value pairs that provide information about this Data Label.</p> It is recommended that any <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair instantaneous values that are referenced are also saved here rather than trying to link this timestamp to <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair recorded value timestamp.",
    )
    label_name: str = Field(
        ...,
        description="This is the name from the Label variable.</p> It can be created with the Kelvin API `/datalabels/labels/create`. If the Label name does not exist when creating a <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a>, it will be automatically created.",
        max_length=64,
    )
    metrics: List[Metric] = Field(
        ...,
        description="An array of JSON objects containing the Kelvin Asset name and Kelvin Metric name pairs that are related to the Data Label.",
    )
    source: DataLabelSource
    start_date: datetime = Field(
        ...,
        description="Timestamp for the start of a time range for which the <a href='https://docs.kelvininc.com/latest/documentation/kelvin-platform/kelvin-api/kelvin-api-categories/data-labels/' target='_blank'>Kelvin Data Label</a> information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).",
    )
    validation: Optional[bool] = Field(
        None,
        description="Option for Machine Learning systems to save the validation results of any model's output",
    )


class DataLabelFilter(DataModelBase):
    """
    DataLabelFilter object.

    Parameters
    ----------
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    search: Optional[List[str]]

    """

    label_names: Optional[List[str]] = Field(
        None,
        description="An optional array of one or more Label Names to filter. All Label names will be filtered using **OR** operator.",
    )
    metrics: Optional[List[Metric]] = Field(
        None,
        description="An optional array of one or more <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> Names to filter. All Label names will be filtered using **OR** operator.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="An optional array of one or more `description` or `label_names` to filter.<p> For example `[pump,fan]`. The search is case insensitive and will find partial matches as well. For example if a `description` or `label_name` is `centrifugal_pump`, then a match will be made if the search string is `pum` or `FUGaL`.",
    )


class DataLabelRange(DataModelBase):
    """
    DataLabelRange object.

    Parameters
    ----------
    end_date: datetime
    label_names: Optional[List[str]]
    metrics: Optional[List[Metric]]
    start_date: datetime

    """

    end_date: datetime = Field(
        ...,
        description="Timestamp for the end of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).</p> If the Data Label is a snapshot in time, the start_time and end_time can be the same.",
    )
    label_names: Optional[List[str]] = Field(
        None,
        description="Filter the returned results based on an Array of Label names.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> Each Label name will be filtered using the `OR` operator.",
    )
    metrics: Optional[List[Metric]] = Field(
        None,
        description="Filter the returned results based on an array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs.</p> Note : If you use this filter parameter, you can not just filter on a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a>. It must be the pair together.</p> Each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair names will be filtered using the `OR` operator.",
    )
    start_date: datetime = Field(
        ...,
        description="Timestamp for the start of a time range for which the Data Label information is relevant (supports RFC3339 with nanosecond precision, e.g. 2022-11-03T08:15:03.278515Z).",
    )


class DataTypeCreate(DataModelBase):
    """
    DataTypeCreate object.

    Parameters
    ----------
    icd: Optional[ICDPayload]
    schema_: Optional[Dict[str, Any]]
    source: Optional[str]

    """

    icd: Optional[ICDPayload] = None
    schema_: Optional[Dict[str, Any]] = Field(None, alias="schema")
    source: Optional[str] = None


class EntityReference(DataModelBase):
    """
    EntityReference object.

    Parameters
    ----------
    metric: ReferenceMetric
    name: str
    title: Optional[str]
    type: str
    visualization: Optional[Dict[str, Any]]

    """

    metric: ReferenceMetric
    name: str = Field(
        ...,
        description="Unique identifier name for the display value in the entity in this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    title: Optional[str] = Field(
        None,
        description="Display name (title) for the display value for the entity in this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
    )
    type: str = Field(
        ...,
        description="The type of reference.</p> There is only one option at the moment; `metric`.",
    )
    visualization: Optional[Dict[str, Any]] = Field(None, description="For internal use only.")


class FailureClassHierarchyUpdate(DataModelBase):
    """
    FailureClassHierarchyUpdate object.

    Parameters
    ----------
    updates: Optional[Dict[str, List[FailureClassHierarchyUpdateItem]]]

    """

    updates: Optional[Dict[str, List[FailureClassHierarchyUpdateItem]]] = None


class FailureDetection(DataModelBase):
    """
    FailureDetection object.

    Parameters
    ----------
    enabled: Optional[bool]
    failure_class_name: Optional[str]
    properties: Optional[List[FailureDetectionProperty]]

    """

    enabled: Optional[bool] = Field(
        None,
        description='The activation state of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p>  `true` (enabled) and `false` (disabled).</p> The default is `false` (disabled).',
    )
    failure_class_name: Optional[str] = Field(
        None,
        description='The unique name (not the Display Name / Title) of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection Class</a>. You can find a full list of available Kelvin Failure Detection AI classes with the API request `/failure-detection/classes/list`.</p> This parameter is only used when <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> is enabled.',
    )
    properties: Optional[List[FailureDetectionProperty]] = Field(
        None,
        description='List of properties required by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-ai-failure-detection/" target="_blank">Kelvin Failure Detection AI</a> model. These options will vary and depends on the `failure_class_name` you have selected.</p> For example if you have a <a href=\'https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor\' target=\'_blank\'>Kelvin Sensor</a> and select the `Vibration Piezo` failure class, then you will need to include information about the sampling rate, sample duration, axial/horizontal/vertical orientations. Any default values not set here must be filled in by the user when adding this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )


class HierarchyUpdateItem(DataModelBase):
    """
    HierarchyUpdateItem object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: str
    delete: Optional[bool]
    entity_type_name: str
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[HierarchyUpdateItem]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#kelvin-templates" target="_blank">Kelvin Template</a> used to create this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> If this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> was created from scratch, then this parameter will be `null`.',
    )
    asset_type_name: str = Field(
        ...,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    delete: Optional[bool] = Field(
        None,
        description="Delete this <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> and its complete <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> If this parameter is marked `true`, then only the `name` is required as a parameter. Default is `false`.",
    )
    entity_type_name: str = Field(
        ...,
        description='Unique identifier name of the entity type linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a>.',
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[HierarchyUpdateItem]] = Field(
        None,
        description="A list of all <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Assets</a> which will include any <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> or <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> that are in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> below this <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Assets</a>.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None,
        description='List of all <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/" target="_blank">Kelvin Metrics</a> linked to this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    name: str = Field(
        ...,
        description='Unique identifier name of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description='List of any custom properties for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
    )
    title: str = Field(
        ...,
        description='Display name (title) of the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class KelvinACPInstanceSettingUpdate(DataModelBase):
    """
    KelvinACPInstanceSettingUpdate object.

    Parameters
    ----------
    payload: Optional[ACPSetting]

    """

    payload: Optional[ACPSetting] = None


class LabelMetadataBulkCreate(BaseModelRoot[LabelMetadataBulkCreateItem]):
    """
    LabelMetadataBulkCreate object.

    Parameters
    ----------
    __root__: List[LabelMetadataBulkCreateItem]

    """

    __root__: List[LabelMetadataBulkCreateItem]


class LabelMetadataBulkDelete(BaseModelRoot[LabelMetadataDeleteBulkItem]):
    """
    LabelMetadataBulkDelete object.

    Parameters
    ----------
    __root__: List[LabelMetadataDeleteBulkItem]

    """

    __root__: List[LabelMetadataDeleteBulkItem]


class MapEntity(DataModelBase):
    """
    MapEntity object.

    Parameters
    ----------
    name: str
    references: Optional[List[EntityReference]]
    title: Optional[str]
    visualization: Optional[Dict[str, Any]]

    """

    name: str = Field(
        ...,
        description="Unique identifier name for the entity in this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    references: Optional[List[EntityReference]] = Field(
        None,
        description="Information on the type of data related to the entity and all the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs.",
    )
    title: Optional[str] = Field(
        None,
        description="Display name (title) for the entity in this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
    )
    visualization: Optional[Dict[str, Any]] = Field(
        None,
        description="Information for the entity display on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> Each entity will have visualization data for the type of display, the symbol to use, the position, the size, the related <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> and a unique id.",
    )


class MapOEECreate(DataModelBase):
    """
    MapOEECreate object.

    Parameters
    ----------
    assets_oee: Optional[List[AssetOEE]]

    """

    assets_oee: Optional[List[AssetOEE]] = Field(
        None,
        description="An array with all the information for each OEE entry for the selected <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.",
    )


class MapShiftCreate(DataModelBase):
    """
    MapShiftCreate object.

    Parameters
    ----------
    production_info: Optional[ProductionInfo]
    shift_info: Optional[ShiftInfo]
    team_info: Optional[List[TeamMember]]

    """

    production_info: Optional[ProductionInfo] = None
    shift_info: Optional[ShiftInfo] = None
    team_info: Optional[List[TeamMember]] = Field(
        None, description="Array of the team members working in this new shift."
    )


class MapUpdate(DataModelBase):
    """
    MapUpdate object.

    Parameters
    ----------
    asset_name: Optional[str]
    entities: Optional[List[MapEntity]]
    mode: Optional[str]
    relationships: Optional[List[MapRelationship]]
    title: Optional[str]

    """

    asset_name: Optional[str] = Field(
        None,
        description="Name of the parent <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> This <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> must be a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> with a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> `site`.",
    )
    entities: Optional[List[MapEntity]] = Field(
        None,
        description="All the entities that make up the process flow in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> This is used with relationships to connect the entities together,",
    )
    mode: Optional[str] = Field(
        None,
        description="The mode of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> There are two options available; `simulation` and `production`.</p> For production mode, all entities must be linked to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> that exists on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a>.</p> For simulation mode, entities do not need to be linked to any existing <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )
    relationships: Optional[List[MapRelationship]] = Field(
        None,
        description="Maps out how each entity is connected to other entities in the process flow in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.",
    )
    title: Optional[str] = Field(
        None,
        description="New display name (title) for thiS <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class MetricExtraField(DataModelBase):
    """
    MetricExtraField object.

    Parameters
    ----------
    computation: Optional[MetricExtraFieldComputation]
    metric_name: Optional[str]
    name: Optional[str]

    """

    computation: Optional[MetricExtraFieldComputation] = None
    metric_name: Optional[str] = Field(
        None,
        description="<a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> name to retrieve the data. This is used in connection with the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> to retrieve relevant data from each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.",
    )
    name: Optional[str] = Field(
        None,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> `extra_field`.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )


class NotificationsUserSetting(DataModelBase):
    """
    NotificationsUserSetting object.

    Parameters
    ----------
    alarms: Optional[Dict[str, AlarmNotificationsUserSetting]]

    """

    alarms: Optional[Dict[str, AlarmNotificationsUserSetting]] = None


class NotificationsUserSettingUpdate(DataModelBase):
    """
    NotificationsUserSettingUpdate object.

    Parameters
    ----------
    payload: Optional[NotificationsUserSetting]

    """

    payload: Optional[NotificationsUserSetting] = None


class RecommendationDataLabel(DataModelBase):
    """
    RecommendationDataLabel object.

    Parameters
    ----------
    confidence: Optional[int]
    description: Optional[str]
    end_date: Optional[str]
    info: Optional[Dict[str, Any]]
    label_name: Optional[str]
    metrics: Optional[List[RecommendationDataLabelMetric]]
    start_date: Optional[str]
    validation: Optional[bool]

    """

    confidence: Optional[int] = None
    description: Optional[str] = None
    end_date: Optional[str] = None
    info: Optional[Dict[str, Any]] = None
    label_name: Optional[str] = None
    metrics: Optional[List[RecommendationDataLabelMetric]] = None
    start_date: Optional[str] = None
    validation: Optional[bool] = None


class RuleExecutionConfig(DataModelBase):
    """
    RuleExecutionConfig object.

    Parameters
    ----------
    loop_config: Optional[LoopConfig]
    mode: Optional[str]
    schedule_config: Optional[ScheduleConfig]

    """

    loop_config: Optional[LoopConfig] = None
    mode: Optional[str] = None
    schedule_config: Optional[ScheduleConfig] = None


class RulePayload(DataModelBase):
    """
    RulePayload object.

    Parameters
    ----------
    actions: Optional[List[RuleAction]]
    execution_config: Optional[RuleExecutionConfig]
    inputs: Optional[List[RuleInput]]
    script: Optional[str]
    visualization: Optional[Dict[str, Any]]

    """

    actions: Optional[List[RuleAction]] = None
    execution_config: Optional[RuleExecutionConfig] = None
    inputs: Optional[List[RuleInput]] = None
    script: Optional[str] = None
    visualization: Optional[Dict[str, Any]] = None


class RuleUpdate(DataModelBase):
    """
    RuleUpdate object.

    Parameters
    ----------
    draft: Optional[bool]
    enabled: Optional[bool]
    map_name: Optional[str]
    payload: Optional[RulePayload]
    target: Optional[str]
    title: Optional[str]

    """

    draft: Optional[bool] = None
    enabled: Optional[bool] = None
    map_name: Optional[str] = Field(None, max_length=64)
    payload: Optional[RulePayload] = None
    target: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


class StorageBulkCreate(DataModelBase):
    """
    StorageBulkCreate object.

    Parameters
    ----------
    data: List[StorageCreate]

    """

    data: List[StorageCreate] = Field(
        ...,
        description="An array of data values for a defined time for any number of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> // <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs to be saved on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a>.</p> Multiple data values for the same <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> // <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair can be saved but if there are conflicting timestamps then the last value only will be saved and the other values lost.",
    )


class StorageLast(DataModelBase):
    """
    StorageLast object.

    Parameters
    ----------
    selectors: List[StorageSelector]

    """

    selectors: List[StorageSelector] = Field(
        ...,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs that you want to retrieve historian data of the last known recorded payload.",
    )


class StorageRangeAdvanced(DataModelBase):
    """
    StorageRangeAdvanced object.

    Parameters
    ----------
    agg: Optional[str]
    end_time: datetime
    fill: Optional[str]
    group_by_selector: Optional[bool]
    order: Optional[Order]
    selectors: List[StorageSelector]
    start_time: datetime
    time_bucket: Optional[str]
    time_shift: Optional[str]

    """

    agg: Optional[str] = Field(
        None,
        description="Perform mathematical calculations on a group of data.</p> For numerical data there are twelve mathematical options available; `none` , `count`,`distinct`, `integral`, `mean`, `median`, `mode`, `spread`, `stddev`, `sum`, `max`, `min`.</p> For text based data there are three types of mathematical options available; `count`, `distinct`, `mode`. The default is `none`.</p> When using this parameter, you must also use the parameters `time_bucket` which defines how to group the data and `fields` which defines which payload data to use.",
    )
    end_time: datetime = Field(
        ...,
        description="End time for the recorded time to collect the payload data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )
    fill: Optional[str] = Field(
        None,
        description="Fills any group of data, which is defined by the `time_bucket` parameter, with a calculated value when there is no data in the database.</p> There are five options available; `none`, `null`, `linear`, `previous`, fixed integer value.</p> `none` will ignore the group. `null`, `previous` and fixed integer value will be added as the value for the empty group. `linear` will perform a linear regression to calculated the groups' value.</p> The default is `none`.",
    )
    group_by_selector: Optional[bool] = Field(
        None,
        description="Defines whether to group all filtered data into one result or separates the results for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair defined in the `selector` parameter.",
    )
    order: Optional[Order] = Field(
        None,
        description="Order of the results for the timestamp parameter.</p> There are two options available (capital letters is required); `ASC` for ascending and `DESC` for descending. The default is `ASC`.",
    )
    selectors: List[StorageSelector] = Field(
        ...,
        description="Array of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pairs that you want to retrieve the data payloads.",
    )
    start_time: datetime = Field(
        ...,
        description="Start time for the recorded time to collect the payload data from the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a> in ISO 8601 UTC date/time format. Example; '2022-07-08T08:41:01.657916Z'.",
        example="2022-01-13T12:00:00.000000Z",
    )
    time_bucket: Optional[str] = Field(
        None,
        description="Group the data by time frame for the `agg` parameter calculations.</p> The time can be adjusted with these time units `ns`, `ms`, `s`, `m`, `h`. e.g. `8765h` equates to is 8,765 hours which is approximately one year.",
    )
    time_shift: Optional[str] = Field(
        None,
        description="Shift the time buckets from the epoch. Every time bucket starts from epoch so, if you want to calculate the time bucket starting on a different date and time, you'll need to set this. Example: `5m`, `1h`, `1w`.",
    )


class AssetCreate(DataModelBase):
    """
    AssetCreate object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: str
    entity_type_name: str
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    asset_type_name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> referenced by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> parameter.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> As this is creating additional <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>, the parameters here are the same as the Create Kelvin Asset.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class AssetCreateWithParent(DataModelBase):
    """
    AssetCreateWithParent object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: str
    entity_type_name: str
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    parent_name: Optional[str]
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    asset_type_name: str = Field(
        ...,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.</p> A 400 error will occur if the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> does not exist and this API request will fail.',
        max_length=64,
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> referenced by the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> parameter.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    name: str = Field(
        ...,
        description='Unique identifier name for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    parent_name: Optional[str] = Field(
        None,
        description='Unique identifier name of an existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a> to assign as the parent to this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.</p> The <a href=\'https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy\' target=\'_blank\'>hierarchy</a> of <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a> must be followed. For example a <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part" target="_blank">Kelvin Asset Part\'s</a> parent must have an entity type `component`. This parameter can be check in the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-class" target="_blank">Kelvin Asset Class</a> that is linked to the <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> that is linked to the existing <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='Display name (title) for this new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset" target="_blank">Kelvin Asset</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class AssetInsightsExtraFields(DataModelBase):
    """
    AssetInsightsExtraFields object.

    Parameters
    ----------
    alarm_statistics: Optional[List[AlarmStatisticsExtraField]]
    asset_properties: Optional[List[AssetPropertyExtraField]]
    control_changes: Optional[List[ControlChangeExtraField]]
    metrics: Optional[List[MetricExtraField]]
    recommendations: Optional[List[RecommendationExtraField]]

    """

    alarm_statistics: Optional[List[AlarmStatisticsExtraField]] = Field(
        None,
        description="Create new columns of an aggregate count of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-alarms/' target='_blank'>Kelvin Alarms</a> based on defined filters of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-alarms/' target='_blank'>Kelvin Alarms</a> that are related to the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> Multiple columns can be created each with its own unique filter combination for `severity` and `status`.",
    )
    asset_properties: Optional[List[AssetPropertyExtraField]] = Field(
        None,
        description="Create new columns based on the `property` field in <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.</p> Multiple columns can be created based with each column related to one custom <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> `property` field.",
    )
    control_changes: Optional[List[ControlChangeExtraField]] = None
    metrics: Optional[List[MetricExtraField]] = Field(
        None,
        description="Create new columns based on mathematical calculations for a time range of a data stream for a defined <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.</p> Multiple columns can be created each with its own defined mathematical formula and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> / <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-metrics/' target='_blank'>Kelvin Metric</a> pair.",
    )
    recommendations: Optional[List[RecommendationExtraField]] = None


class AssetTemplateCreate(DataModelBase):
    """
    AssetTemplateCreate object.

    Parameters
    ----------
    asset_type_name: str
    description: Optional[str]
    entity_type_name: str
    failure_detection: Optional[FailureDetectionTemplate]
    hierarchy: Optional[List[AssetTemplateHierarchy]]
    hints: Optional[Dict[str, Any]]
    image_url: Optional[str]
    metrics: Optional[List[AssetMetricItem]]
    name: str
    properties: Optional[List[AssetTemplateProperties]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_type_name: str = Field(
        ...,
        description='The name (not the Display Name / Title) of the default <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a> that will be selected.</p> This can be changed by the user when adding the Kelvin Template as a new <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Asset</a>.',
        max_length=64,
    )
    description: Optional[str] = Field(
        None, description="A full description of the Kelvin Template.", max_length=512
    )
    entity_type_name: str = Field(
        ...,
        description='Entity type that is linked to this new Kelvin Template.</p> There are 5 entity type options available to choose from; `group`, `asset`, `component`, `part` and `sensor`.</p> Detailed information about the asset hierarchy and function of each entity type can be found at <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/</a>.',
        max_length=64,
    )
    failure_detection: Optional[FailureDetectionTemplate] = None
    hierarchy: Optional[List[AssetTemplateHierarchy]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the Kelvin Template <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    hints: Optional[Dict[str, Any]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    image_url: Optional[str] = Field(
        None,
        description="A http(s) URL link to an image to visually display your template picture next to the description.</p> The file can be in any web-compatible format including jpg, png, gif, animated gif and apng. Even though any size is allowed as it will be automatically resized, it is advised to keep it below 400 x 400 px.</p> If the link is behind a secure login, all login or token details must be incorporated into the URL here.",
    )
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    name: str = Field(
        ...,
        description="Unique identifier name for this new Kelvin Template.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
        max_length=64,
    )
    properties: Optional[List[AssetTemplateProperties]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This can be changed by the user when adding the Kelvin Template as a new <a href=\"https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/\" target=\"_blank\">Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description="Display name (title) for this new Kelvin Template. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class AssetUpdate(DataModelBase):
    """
    AssetUpdate object.

    Parameters
    ----------
    asset_template_name: Optional[str]
    asset_type_name: Optional[str]
    failure_detection: Optional[FailureDetection]
    hierarchy: Optional[List[AssetCreate]]
    location: Optional[AssetLocationItem]
    metrics: Optional[List[AssetMetricItem]]
    properties: Optional[List[AssetPropertyCreate]]
    title: str
    visualization: Optional[Visualization]

    """

    asset_template_name: Optional[str] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    asset_type_name: Optional[str] = Field(
        None,
        description='New link to a unique identifier name for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type" target="_blank">Kelvin Asset Type</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.',
        max_length=64,
    )
    failure_detection: Optional[FailureDetection] = None
    hierarchy: Optional[List[AssetCreate]] = Field(
        None,
        description="Full details of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Assets</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#component' target='_blank'>Kelvin Components</a>, <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#part' target='_blank'>Kelvin Parts</a> and <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#sensor' target='_blank'>Kelvin Sensors</a> in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a>.",
    )
    location: Optional[AssetLocationItem] = None
    metrics: Optional[List[AssetMetricItem]] = Field(
        None, description="Unused. This is reserved as a future feature."
    )
    properties: Optional[List[AssetPropertyCreate]] = Field(
        None,
        description="List of optional properties for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.</p> This is not used within the Kelvin Platform and is available for use by authorized applications to store and retrieve custom properties for each <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a>.",
    )
    title: str = Field(
        ...,
        description='New optional display name (title) for this <a href="https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/" target="_blank">Kelvin Assets</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.',
        max_length=64,
    )
    visualization: Optional[Visualization] = None


class GetAssetsInsights(DataModelBase):
    """
    GetAssetsInsights object.

    Parameters
    ----------
    asset_names: Optional[List[str]]
    asset_types: Optional[List[str]]
    extra_fields: Optional[AssetInsightsExtraFields]
    force_fetch_recommendations: Optional[bool]
    map_names: Optional[List[str]]
    pinned_assets: Optional[List[str]]
    search: Optional[List[str]]
    sort_by: Optional[List[AssetInsightsSortBy]]

    """

    asset_names: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> parameter `name`. This can be used alone or with the `search` parameter where the filter will apply to the search results. This is given as an array, for example `[pump,fan]`.</p> The filter is done on the full name only according to unique identifier name rules (Must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space but not at the beginning or end).</p> For example a search with `[pump,fan]` will return <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> with the name `pump` but not with the names `pumps` or `centrifugal-fan`.",
    )
    asset_types: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> parameter `name`. This can be used alone or with the `search` parameter where the filter will apply to the search results. This is given as an array, for example `[pump,fan]`.</p> The filter is done on the full name only according to unique identifier name rules (Must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space but not at the beginning or end).</p> For example a search with `[pump,fan]` will return <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> with the name `pump` but not with the names `pum`",
    )
    extra_fields: Optional[AssetInsightsExtraFields] = None
    force_fetch_recommendations: Optional[bool] = Field(
        None, description="Option to force fetching of latest recommendations in the request"
    )
    map_names: Optional[List[str]] = Field(
        None,
        description="Filter on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a> parameter `name`. This can be used alone or with the `search` parameter where the filter will apply to the search results. This is given as an array, for example `[pump,fan]`.</p> The filter is done on the full name only according to unique identifier name rules (Must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space but not at the beginning or end).</p> For example a search with `[pump,fan]` will return <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Asset</a> with the name `pump` but not with the names `pumps` or `centrifugal-fan`.",
    )
    pinned_assets: Optional[List[str]] = Field(
        None,
        description="List of <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> names that should always appear at the top of page 1 of any search results.",
    )
    search: Optional[List[str]] = Field(
        None,
        description="Search and filter on <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a>. Both the Display Name and the Name will be included in the search field criteria. This is given as an array, for example `[pump,fan]`.</p> The search is case insensitive and will find partial matches as well. For example if a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> name or display name is `centrifugal_pump`, then a match will be made if the search string is `pum` or `FUGaL`.",
    )
    sort_by: Optional[List[AssetInsightsSortBy]] = Field(
        None, description="Options on sorting the returned results"
    )


class HierarchyUpdate(DataModelBase):
    """
    HierarchyUpdate object.

    Parameters
    ----------
    data: Optional[List[HierarchyUpdateItem]]

    """

    data: Optional[List[HierarchyUpdateItem]] = Field(
        None,
        description="A dictionary with a data property of all <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/' target='_blank'>Kelvin Assets</a> with their <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-hierarchy' target='_blank'>hierarchy</a> structure to update.",
    )


class MapCreate(DataModelBase):
    """
    MapCreate object.

    Parameters
    ----------
    asset_name: Optional[str]
    entities: List[MapEntity]
    mode: str
    name: str
    relationships: List[MapRelationship]
    title: str

    """

    asset_name: Optional[str] = Field(
        None,
        description="Name of the parent <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> for the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> This <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> must be a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-groups' target='_blank'>Kelvin Asset Group</a> with a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset-type' target='_blank'>Kelvin Asset Type</a> `site`.",
    )
    entities: List[MapEntity] = Field(
        ...,
        description="All the entities that make up the process flow in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> This is used with relationships to connect the entities together,",
    )
    mode: str = Field(
        ...,
        description="The mode of the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> There are two options available; `simulation` and `production`.</p> For production mode, all entities must be linked to a <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a> that exists on the <a href='https://docs.kelvininc.com/latest/kelvin-overview/overview/#kelvin-platform' target='_blank'>Kelvin Platform</a>.</p> For simulation mode, entities do not need to be linked to any existing <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-platform/kelvin-assets/#asset' target='_blank'>Kelvin Asset</a>.",
    )
    name: str = Field(
        ...,
        description="Unique identifier name for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.</p> This must contain only lowercase alphanumeric characters. The `.`, `_` and `-` characters are also allowed to separate words instead of a space BUT can not be at the beginning or end of the name.",
    )
    relationships: List[MapRelationship] = Field(
        ...,
        description="Maps out how each entity is connected to other entities in the process flow in the <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>.",
    )
    title: str = Field(
        ...,
        description="Display name (title) for this new <a href='https://docs.kelvininc.com/latest/kelvin-overview/kelvin-maps/kelvin-maps-overview/#processes' target='_blank'>Kelvin Process Map</a>. This is a friendly name displayed in lists and in references within asset details.</p> You can use any character, numeric, space and special character in this parameter.",
    )


class RecommendationActions(DataModelBase):
    """
    RecommendationActions object.

    Parameters
    ----------
    alarms: Optional[List[RecommendationAlarm]]
    control_changes: Optional[List[RecommendationControlChange]]
    datalabels: Optional[List[RecommendationDataLabel]]

    """

    alarms: Optional[List[RecommendationAlarm]] = None
    control_changes: Optional[List[RecommendationControlChange]] = None
    datalabels: Optional[List[RecommendationDataLabel]] = None


class RecommendationCreate(DataModelBase):
    """
    RecommendationCreate object.

    Parameters
    ----------
    actions: Optional[RecommendationActions]
    confidence: Optional[int]
    custom_identifier: Optional[str]
    description: Optional[str]
    expiration_date: Optional[str]
    metadata: Optional[Dict[str, Any]]
    resource: Optional[str]
    source: Optional[str]
    type: Optional[str]

    """

    actions: Optional[RecommendationActions] = None
    confidence: Optional[int] = None
    custom_identifier: Optional[str] = None
    description: Optional[str] = None
    expiration_date: Optional[str] = None
    metadata: Optional[Dict[str, Any]] = None
    resource: Optional[str] = None
    source: Optional[str] = None
    type: Optional[str] = None


class RuleCreate(DataModelBase):
    """
    RuleCreate object.

    Parameters
    ----------
    draft: Optional[bool]
    enabled: Optional[bool]
    map_name: Optional[str]
    name: Optional[str]
    payload: Optional[RulePayload]
    target: Optional[str]
    title: Optional[str]

    """

    draft: Optional[bool] = None
    enabled: Optional[bool] = None
    map_name: Optional[str] = Field(None, max_length=64)
    name: Optional[str] = Field(None, max_length=52)
    payload: Optional[RulePayload] = None
    target: Optional[str] = Field(None, max_length=64)
    title: Optional[str] = Field(None, max_length=64)


AssetTemplateHierarchy.update_forward_refs()
HierarchyUpdateItem.update_forward_refs()
AssetCreate.update_forward_refs()
